<?php
/***************************************************************************\
 *  ComptaSPIP, extension comptable
 *
 * @read (licence, copyrigth, authors, credits)
 *  ../plugin.xml
\***************************************************************************/

if (!defined('_ECRIRE_INC_VERSION'))
	return;

// Plan comptable prenant en compte les nouvelles dispositions du règlement :
// N° 99-08 et n° 99-09 du 24 novembre 1999 (publiés dans le JO du 31/12/1999);
// N° 99-03 du 29 avril 1999 du Comité de la réglementation comptable (publié dans le JO du 21/09/1999);
// N° 99-01 du 16 février 1999 relatif aux modalités d’établissement des comptes annuels des associations et fondations ;
//
// NB : organisme = association/entreprise/société/exploitant
//
// http://www.plancomptable.com/titre-IV/liste_des_comptes_sb.htm
// http://www.formation-logiciel-comptabilite.fr/Plan-comptable-definition-et-PCG?lang=fr
// http://fr.wikipedia.org/wiki/Plan_comptable_g%C3%A9n%C3%A9ral_%28France%29
// http://www.expertisecomptable-foucher.com/sup/download2.php?file_id=4124
// http://lump.pagesperso-orange.fr/compta.htm
// http://www.mesexercices.com/recherche_information/comptabilite-les-comptes-de-classe-6-charges-sont-normalement_6_38694.htm
//  http://dz.viadeo.com/fr/questions/repondre/?questionId=0021aox4cgt6v70a
// Plan comptable général 2008, Éditions Economica, 2006 : ref.KPMG=1356 ; EAN=978-2-7178-5565-4
//
$GLOBALS[$GLOBALS['idx_lang']] = array(

	'1' => "Comptes de capitaux",
	'10' => "Fonds associatifs et réserves",
	'101' => "Capital", // À qualifier selon la forme juridique de l’organisme (capital social, individuel, …)
	'1011' => "Capital souscrit – non appelé",
	'1012' => "Capital souscrit – appelé, non versé",
	'1013' => "Capital souscrit – appelé, versé",
	'10131' => "Capital non amorti",
	'10132' => "Capital amorti",
	'1018' => "Capital souscrit soumis à des réglementations particulières",
	'102' => "Fonds associatifs sans droit de reprise", // = Fonds fiduciaire
	'1021' => "Valeur du patrimoine intégré",
	'1022' => "Fonds statutaires", // (à éclater en fonction des statuts)
	'10221' => "Dotations pérennes représentatives d’actifs inaliénables",
	'10222' => "Dotations pérennes représentatives d’actifs aliénables",
	'1023' => "Subventions d’investissement non renouvelables",
	'1024' => "Apports sans droit de reprise",
	'1025' => "Legs et donation avec contrepartie d’actifs immobilisés",
	'1026' => "Subventions d’investissement affectées à des biens renouvelables par l’organisme",
	'10261' => "Subventions d’équipement",
	'10268' => "Autres subventions de fonctionnement",
	'1027' => "Autres fonds propres : dotations consomptibles",
	'10279' => "Autres fonds propres : dotations consomptibles inscrites au compte de résultat",
	'103' => "Fonds associatif avec droit de reprise",
	'1031' => "Valeur des biens affectés repris à la fin du contrat d’apport",
	'1032' => "Valeur des biens affectés repris à la dissolution de l’organisme",
	'1033' => "Valeur des biens non affectés repris à la fin du contrat d’apport",
	'1034' => "Apports avec droit de reprise",
	'1035' => "Legs et donations avec contrepartie d’actifs immobilisés assortis d’une obligation ou d’une condition",
	'1036' => "Subventions d’investissement affectées à des biens renouvelables",
	'1039' => "Fond associatif avec droit de reprise inscrit au compte de résultat",
	'104' => "Primes liées au capital social",
	'1041' => "Primes d’émission",
	'1042' => "Primes de fusion",
	'1043' => "Primes d’apport",
	'1044' => "Primes de conversion d’obligations en actions",
	'1045' => "Bons de souscription d’actions",
	'105' => "Écarts de réévaluation",
	'1051' => "Écarts de réévaluation sur des biens sans droit de reprise", // Réserve consécutive à l’application de la loi n° 59-1472 du 28 décembre 1959.
	'1052' => "Écarts de réévaluation sur des biens avec droit de reprise",
	'1053' => "Réserve de réévaluation", // Réserve consécutive à l’application de la loi n° 76-1232 du 29 décembre 1976.
	'1055' => "Écarts de réévaluation (autres opérations légales)",
#	'1056' => "", // compte supprimé
	'1057' => "Autres écarts de réévaluation en France",
	'1058' => "Autres écarts de réévaluation à l’Étranger",
	'106' => "Réserves",
	'1061' => "Réserve légale",
	'10611' => "Réserve légale proprement dite",
	'10612' => "Plus-values nettes à long terme",
	'1062' => "Réserves indisponibles",
	'1063' => "Réserves statutaires ou contractuelles", // Notamment les réserves prévues dans les statuts des organismes reconnues d’utilité publique.
	'1064' => "Réserves réglementées",
	'10641' => "Plus-values nettes à long terme",
	'10643' => "Réserves consécutives à l’octroi de subventions d’investissement",
	'10648' => "Autres réserves réglementées",
	'1068' => "Autres réserves (dont réserves pour projet associatif)",
	'10681' => "Réserve de propre assureur",
	'10682' => "Réserves pour investissements",
	'10683' => "Réserves de trésorerie (provenant du résultat)",
	'10688' => "Réserves diverses",
	'107' => "Écart d’équivalence",
	'108' => "Compte de l’exploitant",
	'109' => "Actionnaires : Capital souscrit – non appelé",
	'11' => "Eléments en instance d’affectation", // Le compte 11 peut être subdivisé afin de distinguer le report à nouveau bénéficiaire et le report à nouveau déficitaire. En l’absence de bénéfices, les intérêts intercalaires, alloués aux apports des associés en vertu d’une clause de garantie par l’État d’un dividende minimal, sont inscrits au compte 11.
	'110' => "Report à nouveau (solde créditeur)",
	'115' => "Résultats sous contrôle de tiers financeurs",
	'119' => "Report à nouveau (solde débiteur)",
	'12' => "Résultat net de l’exercice", // Les entités peuvent utiliser les comptes 120 ou 129 pour enregistrer le bénéfice ou la perte. Elles ont la faculté d’utiliser les comptes 121 à 128, à leur convenance, pour dégager, par exemple, des soldes intermédiaires de gestion.
	'120' => "Résultat de l’exercice (excédent)",
	'129' => "Résultat de l’exercice (déficit)",
	'13' => "Subventions d’investissement affectés à des biens non renouvelables par l’organisme",
	'131' => "Subventions d’équipement",
	'1311' => "– État",
	'1312' => "– Régions",
	'1313' => "– Départements",
	'1314' => "– Communes",
	'1315' => "– Collectivités publiques",
	'1316' => "– Entreprises publiques",
	'1317' => "– Entreprises et organismes privés",
	'1318' => "– Autres",
	'138' => "Autres subventions d’investissement",
	'1381' => "– État",
	'1382' => "– Régions",
	'1383' => "– Départements",
	'1384' => "– Communes",
	'1385' => "– Collectivités publiques",
	'1386' => "– Entreprises publiques",
	'1387' => "– Entreprises et organismes privés",
	'1388' => "– Autres",
	'139' => "Subventions d’investissement inscrites au compte de résultat",
	'1391' => "Subventions d’équipement",
	'13911' => "– État",
	'13912' => "– Régions",
	'13913' => "– Départements",
	'13914' => "– Communes",
	'13915' => "– Collectivités publiques",
	'13916' => "– Entreprises publiques",
	'13917' => "– Entreprises et organismes privés",
	'13918' => "– Autres",
	'1398' => "Autres subventions d’investissement",
	'13981' => "– État",
	'13982' => "– Régions",
	'13983' => "– Départements",
	'13984' => "– Communes",
	'13985' => "– Collectivités publiques",
	'13986' => "– Entreprises publiques",
	'13987' => "– Entreprises et organismes privés",
	'13988' => "– Autres",
	'14' => "Provisions réglementées",
	'141' => "Provisions réglementées affectées à la couverture du besoin en fonds de roulement",
	'142' => "Provisions réglementées pour renouvellement d’immobilisations",
	'1423' => "Provisions pour reconstitution des gisements miniers et pétroliers",
	'1424' => "Provisions pour investissement (participation des salariés)",
	'143' => "Provisions réglementées relatives aux stocks",
	'1431' => "Hausse des prix",
	'1432' => "Fluctuation des cours",
	'144' => "Provisions réglementées relatives aux autres éléments de l’actif",
	'145' => "Amortissements dérogatoires",
	'146' => "Provision spéciale de réévaluation", // Provision consécutive à l’application de la loi n° 77-1467 du 30 décembre 1977.
	'147' => "Plus-values réinvesties", // Assimilées à des amortissements dérogatoires.
	'148' => "Réserves des plus-values", // = Autres provisions réglementées
	'14861' => "Réserves des plus-values nettes d’actif immobilisé",
	'14862' => "Réserves des plus-values nettes d’actif circulant",
	'15' => "Provisions pour risques et charges",
	'151' => "Provisions pour risques",
	'1511' => "Provisions pour litiges",
	'1512' => "Provisions pour garanties données aux clients",
	'1513' => "Provisions pour pertes sur marchés à terme",
	'1514' => "Provisions pour amendes et pénalités",
	'1515' => "Provisions pour pertes de change",
	'1516' => "Provisions pour risques d’emploi",
	'1518' => "Autres provisions pour risques",
	'153' => "Provisions pour pensions et obligations similaires",
	'154' => "Provisions pour restructurations",
	'155' => "Provisions pour impôts",
	'156' => "Provisions pour renouvellement des immobilisations (entreprises concessionnaires)",
	'157' => "Provisions pour charges à répartir sur plusieurs exercices",
	'1572' => "Provisions pour gros entretiens ou grandes révisions",
	'158' => "Autres provisions pour charges",
	'1581' => "Provisions pour remises en état",
#	'1582' => "Provisions pour cotisations sociales et fiscales sur congés à payer", // compte supprimé
	'16' => "Emprunts et dettes assimilées", // Les comptes de base (sur trois chiffres) peuvent être subdivisé à l’initiative des organismes pour distinguer les opérations faites et France ou à l’Étranger, en Euros ou en devises, et selon qu’elles sont traitées à long/moyen/court terme.
	'161' => "Emprunts obligataires convertibles",
	'162' => "Obligations représentatives de passifs nets remis en fiducie",
	'163' => "Autres emprunts obligataires",
	'164' => "Emprunts auprès des établissements de crédit",
	'1641' => "Emprunts à moyen et long terme foncier", // (intérêt 6611)
	'1642' => "Emprunts à moyen et long terme exploitation", // (intérêt 6612)
	'1643' => "Emprunts à court terme (court terme attente)", // (intérêt 6613)
	'165' => "Dépôts et cautionnements reçus",
	'1651' => "Dépôts",
	'1655' => "Cautionnements",
	'166' => "Participation des salariés aux résultats",
	'1661' => "Comptes bloqués", // Débit du compte 424 du montant des fonds qui n’ont pas pu être utilisés par suite d’absence d’accord entre employeurs et salariés
	'1662' => "Fonds de participation",
	'167' => "Emprunts et dettes assorties de conditions particulières",
	'1671' => "Émissions de titres participatifs",
	'1672' => "Titre associatif",
	'1674' => "Avances conditionnées de l’État",
	'1675' => "Emprunts participatifs",
#	'1676' => "", // compte supprimé
	'168' => "Autres emprunts et dettes assimilées",
	'1681' => "Autres emprunts (dont Prêts familiaux)",
	'1685' => "Rentes viagères capitalisées",
	'1687' => "Autres dettes",
	'1688' => "Intérêts courus",
	'16881' => "Sur emprunts obligataires convertibles",
	'16883' => "Sur autres emprunts obligataires",
	'16884' => "Sur emprunts auprès des établissements de crédit",
	'16885' => "Sur dépôts et cautionnements reçus",
	'16886' => "Sur participation des salariés aux résultats",
	'16887' => "Sur emprunts et dettes assortis de conditions particulières",
	'16888' => "Sur autres emprunts et dettes assimilées",
	'169' => "Primes de remboursement des obligations",
	'17' => "Dettes rattachées à des participations", // Les comptes de base (sur trois chiffres) peuvent être subdivisé à l’initiative des organismes pour distinguer les opérations faites et France ou à l’Étranger, en Euros ou en devises, et selon qu’elles sont traitées à long/moyen/court terme.
	'171' => "Dettes rattachées à des participations (groupe)",
	'174' => "Dettes rattachées à des participations (hors groupe)",
	'178' => "Dettes rattachées à des sociétés en participation",
	'1781' => "Principal",
	'1788' => "Intérêts courus",
	'18' => "Comptes de liaison des établissements et sociétés en participation",
	'181' => "Compte de liaison entre siège social et établissements",
	'186' => "Biens et prestations échangés entre établissement (charges)",
	'187' => "Biens et prestations échangés entre établissement (produits)",
	'188' => "Comptes de liaison des sociétés en participation",
	'19' => "Fonds dédiés",
	'193' => "Fonds dédiés aux fondations abritées",
	'194' => "Fonds dédiés sur subventions de fonctionnement",
	'195' => "Fond dédiés sur dons manuels affectés",
	'197' => "Fonds dédiés sur legs et donations affectés",
	'198' => "Excédent disponible après affectation au projet associatif",
	'199' => "Reprise des fonds affectés au projet associatif",

	'2' => "Comptes d’immobilisations",
	'20' => "Immobilisations incorporelles",
	'201' => "Frais d’établissement",
	'2011' => "Frais de constitution",
	'2012' => "Frais de premier établissement",
	'20121' => "Frais de prospection",
	'20122' => "Frais de publicité",
	'2013' => "Frais d’augmentation de capital et d’opérations diverses (fusions, scissions, transformations)",
	'203' => "Frais de recherche et de développement",
	'205' => "Concessions et droits similaires, brevets, licences, marques, procédés, logiciels, droits et valeurs similaires",
	'206' => "Droit au bail",
	'207' => "Fonds commercial",
	'208' => "Autres immobilisations incorporelles",
	'21' => "Immobilisations corporelles",
	'211' => "Terrains",
	'2111' => "Terrains nus",
	'2112' => "Terrains aménagés",
	'2113' => "Sous-sols et sur-sols",
	'2114' => "Terrains de gisement",
	'21141' => "Carrières",
	'2115' => "Terrains bâtis",
	'21151' => "Ensembles immobiliers industriels (A, B, …)",
	'21155' => "Ensembles immobiliers administratifs et commerciaux (A, B, …)",
	'21158' => "Autres ensembles immobiliers",
	'211581' => "Affectés aux opérations professionnelles (A, B, …)",
	'211588' => "Affectés aux opérations non professionnelles (A, B, …)",
	'2116' => "Compte d’ordre sur immobilisation", // (art. 6 du décret n°78-737 du 11 juillet 1978)
	'212' => "Agencements et aménagements de terrains", // (même ventilation que celle du compte 211)
	'2121' => "Aménagement foncier de drainages",
	'2128' => "Aménagement foncier non amortissables",
	'213' => "Constructions",
	'2131' => "Bâtiments",
	'21311' => "Ensembles immobiliers industriels (A, B, …)",
	'21315' => "Ensembles immobiliers administratifs et commerciaux (A, B, …)",
	'21318' => "Autres ensembles immobiliers",
	'213181' => " Affectés aux opérations professionnelles (A, B, …)",
	'213188' => " Affectés aux opérations non professionnelles (A, B, …)",
	'2135' => "Installations générales, agencements, aménagements des constructions",
	'21351' => "Ensembles immobiliers industriels (A, B, …)",
	'21355' => "Ensembles immobiliers administratifs et commerciaux (A, B, …)",
	'21358' => "Autres ensembles immobiliers",
	'213581' => " Affectés aux opérations professionnelles (A, B, …)",
	'213588' => " Affectés aux opérations non professionnelles (A, B, …)",
	'2138' => "Ouvrages d’infrastructure",
	'21381' => "Voies de terre",
	'21382' => "Voies de fer",
	'21383' => "Voies d’eau",
	'21384' => "Barrages",
	'21385' => "Pistes d’aérodromes",
	'214' => "Constructions sur sol d’autrui",
	'2141' => "Bâtiments",
	'21411' => "Ensembles immobiliers industriels (A, B, …)",
	'21415' => "Ensembles immobiliers administratifs et commerciaux (A, B, …)",
	'21418' => "Autres ensembles immobiliers",
	'214181' => " Affectés aux opérations professionnelles (A, B, …)",
	'214188' => " Affectés aux opérations non professionnelles (A, B, …)",
	'2145' => "Installations générales, agencements, aménagements des constructions",
	'21451' => "Ensembles immobiliers industriels (A, B, …)",
	'21455' => "Ensembles immobiliers administratifs et commerciaux (A, B, …)",
	'21458' => "Autres ensembles immobiliers",
	'214581' => " Affectés aux opérations professionnelles (A, B, …)",
	'214588' => " Affectés aux opérations non professionnelles (A, B, …)",
	'2148' => "Ouvrages d’infrastructure",
	'21481' => "Voies de terre",
	'21482' => "Voies de fer",
	'21483' => "Voies d’eau",
	'21484' => "Barrages",
	'21485' => "Pistes d’aérodromes",
	'215' => "Installations techniques, matériel et outillage industriels",
	'2151' => "Installations complexes spécialisées", // Ex. : salle de traite, silo
	'21511' => "– sur sol propre",
	'21514' => "– sur sol d’autrui",
	'2153' => "Installations à caractère spécifique",
	'21531' => "– sur sol propre",
	'21534' => "– sur sol d’autrui",
	'2154' => "Matériel industriel", // Les organismes pour lesquels la distinction entre les comptes 2154, 2155 et 2157 n’est pas indispensable peuvent regrouper ces comptes sous le compte 2154 dont l’intitulé est complété en conséquence.
	'2155' => "Outillage industriel", // Les organismes pour lesquels la distinction entre les comptes 2154, 2155 et 2157 n’est pas indispensable peuvent regrouper ces comptes sous le compte 2154 dont l’intitulé est complété en conséquence.
	'2157' => "Agencements et aménagements du matériel et outillage industriels", // Les organismes pour lesquels la distinction entre les comptes 2154, 2155 et 2157 n’est pas indispensable peuvent regrouper ces comptes sous le compte 2154 dont l’intitulé est complété en conséquence.
	'218' => "Autres immobilisations corporelles",
	'2181' => "Installations générales, agencements, aménagements divers", // Dans des constructions dont l’organisme n’est pas propriétaire.
	'2182' => "Matériel de transport",
	'2183' => "Matériel de bureau et matériel informatique",
	'2184' => "Mobilier",
	'2185' => "Cheptel",
	'2186' => "Emballages récupérables",
	'22' => "Immobilisations mises en concession",
	'221' => "Constructions", // usage courant, mais ce compte ne fait pas partir du plan comptable
	'223' => "Autres droits réels sur des immeubles", // usage courant, mais ce compte ne fait pas partir du plan comptable
	'228' => "Immobilisations grevées de droits",
	'229' => "Droits des propriétaires (pour enregistrer les commodats)",
	'23' => "Immobilisations en cours",
	'231' => "Immobilisations corporelles en cours",
	'2312' => "Terrains",
	'2313' => "Constructions",
	'2315' => "Installations techniques, matériel et outillage industriels",
	'2318' => "Autres immobilisations corporelles",
	'232' => "Immobilisations incorporelles en cours",
	'237' => "Avances et acomptes versés sur commandes d’immobilisations incorporelles",
	'238' => "Avances et acomptes versés sur commandes d’immobilisations corporelles",
	'2382' => "Terrains",
	'2383' => "Constructions",
	'2385' => "Installations techniques, matériel et outillage industriels",
	'2388' => "Autres immobilisations corporelles",
	'25' => "Parts dans des entreprises liées et créances sur des entreprises liées",
	'26' => "Participations et créances rattachées à des participations", // Les comptes de base (sur trois chiffres) peuvent être subdivisé à l’initiative des organismes pour distinguer les opérations faites et France ou à l’Étranger, en Euros ou en devises, et selon qu’elles sont traitées à long/moyen/court terme.
	'261' => "Titres de participation",
	'2611' => "Actions",
	'2618' => "Autres titres",
	'262' => "Titres évalués par équivalence, Parts sociales coop, SICA",
	'266' => "Autres formes de participation",
	'267' => "Créances rattachées à des participations",
	'2671' => "Créances rattachées à des participations (groupe)",
	'2674' => "Créances rattachées à des participations (hors groupe)",
	'2675' => "Versements représentatifs d’apports non capitalisés (appel de fonds)",
	'2676' => "Avances consolidables", // Au sens financier du terme.
	'2677' => "Autres créances rattachées à des participations",
	'2678' => "Intérêts courus",
	'268' => "Créances rattachées à des sociétés en participation",
	'2681' => "Principal",
	'2688' => "Intérêts courus",
	'269' => "Versements restant à effectuer sur titres de participation non libérés",
	'27' => "Autres immobilisations financières", // Les comptes de base (sur trois chiffres) peuvent être subdivisé à l’initiative des organismes pour distinguer les opérations faites et France ou à l’Étranger, en Euros ou en devises, et selon qu’elles sont traitées à long/moyen/court terme.
	'271' => "Titres immobilisés (droit de propriété)",
	'2711' => "Actions",
	'2715' => "Parts sociales crédit agricole",
	'2718' => "Autres titres",
	'272' => "Titres immobilisés (droit de créance)",
	'2721' => "Obligations",
	'2722' => "Bons",
	'2728' => "Autres",
	'273' => "Titres immobilisés de l’activité portefeuille (TIAP)",
	'274' => "Prêts",
	'2741' => "Prêts participatifs",
	'2742' => "Prêts aux associés",
	'2743' => "Prêts au personnel",
	'2748' => "Autres prêts",
	'275' => "Dépôts et cautionnements versés",
	'2751' => "Dépôts",
	'2755' => "Cautionnements",
	'276' => "Autres créances immobilisées",
	'2761' => "Créances diverses",
	'2768' => "Intérêts courus",
	'27682' => "Sur titres immobilisés (droits de créance)",
	'27684' => "Sur prêts",
	'27685' => "Sur dépôts et cautionnements",
	'27688' => "Sur créances diverses",
	'277' => "Actions propres ou parts propres",
	'2771' => "Actions propres ou parts propres",
	'2772' => "Actions propres ou parts propres en voie d’annulation",
	'279' => "Versements restant à effectuer sur titres immobilisés non libérés",
	'28' => "Amortissements des immobilisations",
	'280' => "Amortissements des immobilisations incorporelles", // Le compte 280 ne doit pas être utilisé pour regrouper les comptes 281 et suivants.
	'2801' => "Frais d’établissement", // (même ventilation que celle du compte 201)
	'2803' => "Frais de recherche et développement",
	'2805' => "Concessions et droits similaires, brevets, licences, logiciels, droits et valeurs similaires",
	'2807' => "Fonds commercial",
	'2808' => "Autres immobilisations incorporelles",
	'281' => "Amortissements des immobilisations corporelles",
	'2811' => "Terrains de gisement",
	'2812' => "Agencements, aménagements de terrains", // (même ventilation que celle du compte 212)
	'2813' => "Constructions", // (même ventilation que celle du compte 213)
	'2814' => "Construction sur sol d’autrui", // (même ventilation que celle du compte 214)
	'2815' => "Installations techniques, matériel et outillage industriels", // (même ventilation que celle du compte 215)
	'2818' => "Autres immobilisations corporelles", // (même ventilation que celle du compte 218)
	'282' => "Amortissements des immobilisations mises en concession",
	'29' => "Provisions pour dépréciation des immobilisations",
	'290' => "Provisions pour dépréciation des immobilisations incorporelles", // Le compte 290 ne doit pas être utilisé pour regrouper les comptes 291 et suivants.
	'2905' => "Marques, procédés, droits, et valeurs similaires",
	'2906' => "Droit au bail",
	'2907' => "Fonds commercial",
	'2908' => "Autres immobilisations incorporelles",
	'291' => "Provisions pour dépréciation des immobilisations corporelles",
	'2911' => "Terrains", // (autres que terrains de gisements)
	'292' => "Provisions pour dépréciations des immobilisations mises en concession",
	'293' => "Provisions pour dépréciations des immobilisations en cours",
	'2931' => "Immobilisations corporelles en cours",
	'2932' => "Immobilisations incorporelles en cours",
	'296' => "Provisions pour dépréciation des participations et créances rattachées à des participations",
	'2961' => "Tires de participation",
	'2966' => "Autres formes de participation",
	'2967' => "Créances rattachées à des participations", // (même ventilation que celle du compte 267)
	'2968' => "Créances rattachées à des sociétés en participation", // (même ventilation que celle du compte 268)
	'297' => "Provisions pour dépréciation des autres immobilisations financières",
	'2971' => "Titres immobilisés – droit de propriété", // (même ventilation que celle du compte 271)
	'2972' => "Titres immobilisés – droit de créance", // (même ventilation que celle du compte 272)
	'2973' => "Titres immobilisés de l’activité portefeuille", // (même ventilation que celle du compte 273)
	'2974' => "Prêts", // (même ventilation que celle du compte 274)
	'2975' => "Dépôts et cautionnements versés", // (même ventilation que celle du compte 275)
	'2976' => "Autres créances immobilisées", // (même ventilation que celle du compte 276)

	'3' => "Comptes de stocks et en-cours", // La structure des comptes cette classe 3 sera harmonisee avec celle adoptee pour les comptes 60 et 70. Les associations releveront le plus souvent, non pas de l’inventaire permanent, mais de l’inventaire intermittent.
	'31' => "Matières premières et fournitures", // Les organismes qui relèvent du système abrégé regroupent les comptes 31 et 32 sous le même compte 31 dont l’intulé devient "Stocks – Approvisionnements".
	'311' => "Matières (ou groupe) A",
	'312' => "Matières (ou groupe) B",
	'317' => "Fournitures A, B, C, …",
	'32' => "Autres approvisionnements", // Les organismes qui relèvent du système abrégé regroupent les comptes 31 et 32 sous le même compte 31 dont l’intulé devient "Stocks – Approvisionnements".
	'321' => "Matières consommables", // Lorsque la distinction entre "Matières consommables" et "Fournitures consommables" n’est pas indispensable, les organismes peuvent regrouper les comptes 321 et 322 sous le numéro 321 dont l’intulé est complété en conséquence : "Matières et fournitures consommables".
	'3211' => "Matières (ou groupe) C",
	'3212' => "Matières (ou groupe) D",
	'322' => "Fournitures consommables", // Lorsque la distinction entre "Matières consommables" et "Fournitures consommables" n’est pas indispensable, les organismes peuvent regrouper les comptes 321 et 322 sous le numéro 321 dont l’intulé est complété en conséquence : "Matières et fournitures consommables".
	'3221' => "Combustibles",
	'3222' => "Produits d’entretien",
	'3223' => "Fournitures d’atelier et d’usine",
	'3224' => "Fournitures de magasin",
	'3225' => "Fournitures de bureau",
	'326' => "Emballages",
	'3261' => "Emballages perdus",
	'3265' => "Emballages récupérables non identifiables",
	'3267' => "Emballages à usage mixte",
	'33' => "En-cours de production de biens", // Les organismes relevant du système abrégé peuvent regrouper, le cas échéant, les comptes 33 et 34 et 35 sous le numéro 35 dont l’intulé devient "Stocks de produits et en-cours de production".
	'331' => "Produits en cours",
	'3311' => "Produits en cours P 1",
	'3312' => "Produits en cours P 2",
	'335' => "Travaux en cours ",
	'3351' => "Travaux en cours  T1",
	'3352' => "Travaux en cours  T2",
	'34' => "En-cours de production de services", // Les organismes relevant du système abrégé peuvent regrouper, le cas échéant, les comptes 33 et 34 et 35 sous le numéro 35 dont l’intulé devient "Stocks de produits et en-cours de production".
	'341' => "Études en cours",
	'3411' => "Études en cours E 1",
	'3412' => "Études en cours E 2",
	'345' => "Prestations de service en cours",
	'3451' => "Prestations de services S 1",
	'3452' => "Prestations de services S 2",
	'35' => "Stocks de produits", // Les organismes relevant du système abrégé peuvent regrouper, le cas échéant, les comptes 33 et 34 et 35 sous le numéro 35 dont l’intulé devient "Stocks de produits et en-cours de production".
	'351' => "Produits intermédiaires",
	'3511' => "Produits intermédiaires (ou groupe) A",
	'3512' => "Produits intermédiaires (ou groupe) B",
	'355' => "Produits finis",
	'3551' => "Produits finis (ou groupe) A",
	'3552' => "Produits finis (ou groupe) B",
	'358' => "Produits résiduels (ou matières de récupération)",
	'3581' => "Déchets",
	'3585' => "Rebuts",
	'3586' => "Matières de récupération",
	'36' => "Stocks provenant d’immobilisations", // Compte à ouvrir le cas échéant.
	'37' => "Stocks de marchandises",
	'371' => "Marchandises (ou groupe) A",
	'372' => "Marchandises (ou groupe) B",
	'38' => "Stocks en voie d’acheminement, mis en dépôt ou donnés en consignation", // Lorsque l’organisme tient un inventaire permanent en comptabilité générale, le compte 38 peut être utilisé pour comptabiliser leurs stocks en voie d'acheminement, mis en dépôt ou donnés en consignation.
	'39' => "Provisions pour dépréciation des stocks et en-cours",
	'391' => "Provisions pour dépréciation des matières premières et fournitures", // Les organismes relevant du système abrégé qui regroupent les comptes 31 et 32 sous le numéro 31 utilisent le compte 391 dont l’intitule devient "Provisions pour dépréciation des stocks – Approvisionnements".
	'3911' => "Matières (ou groupe) A",
	'3912' => "Matières (ou groupe) B",
	'3917' => "Fournitures A, B, C, …",
	'392' => "Provisions pour dépréciation des autres approvisionnements", // (même ventilation que celle du compte 32) Les organismes relevant du système abrégé qui regroupent les comptes 31 et 32 sous le numéro 31 utilisent le compte 391 dont l’intitule devient "Provisions pour dépréciation des stocks – Approvisionnements".
	'3921' => "Matières consommables", // (même ventilation que celle du compte 321)
	'3922' => "Fournitures consommables", // (même ventilation que celle du compte 322)
	'3926' => "Emballages", // (même ventilation que celle du compte 326)
	'393' => "Provisions pour dépréciation des en-cours de production de biens", // (même ventilation que celle du compte 33) Les organismes relevant du système abrégé qui regroupent les comptes 33 et 34 et 35 sous le numéro 35 utilisent le compte 395 dont l’intitule devient "Provisions pour dépréciation des stocks de produits et en-cours de production".
	'3931' => "Produits en cours", // (même ventilation que celle du compte 331)
	'3935' => "Travaux en cours", // (même ventilation que celle du compte 335)
	'394' => "Provisions pour dépréciation des en-cours de production de services", // (même ventilation que celle du compte 34) Les organismes relevant du système abrégé qui regroupent les comptes 33 et 34 et 35 sous le numéro 35 utilisent le compte 395 dont l’intitule devient "Provisions pour dépréciation des stocks de produits et en-cours de production".
	'3941' => "Études en cours", // (même ventilation que celle du compte 341)
	'3945' => "Prestations de services en cours", // (même ventilation que celle du compte 345)
	'395' => "Provisions pour dépréciation des stocks de produits", // (même ventilation que celle du compte 35) Les organismes relevant du système abrégé qui regroupent les comptes 33 et 34 et 35 sous le numéro 35 utilisent le compte 395 dont l’intitule devient "Provisions pour dépréciation des stocks de produits et en-cours de production".
	'3951' => "Produits intermédiaires", // (même ventilation que celle du compte 351)
	'3955' => "Produits finis", // (même ventilation que celle du compte 355)
	'397' => "Provisions pour dépréciation des stocks de marchandises",
	'3971' => "Marchandises (ou groupe) A",
	'3972' => "Marchandises (ou groupe) B",

	'4' => "Comptes de tiers",
	'40' => "Fournisseurs et comptes rattachés", // Les comptes de base (sur trois chiffres) peuvent être subdivisé à l’initiative des organismes pour distinguer les opérations faites et France ou à l’Étranger, en Euros ou en devises, et selon qu’elles sont traitées à long/moyen/court terme.
	'400' => "Fournisseurs et comptes rattachés",
	'401' => "Fournisseurs", // (Factures de dettes)
	'4011' => "Fournisseurs – Achats de biens ou de prestations de services",
	'4017' => "Fournisseurs – Retenues de garantie",
	'4096' => "Emballages consignés",
	'403' => "Fournisseurs – Effets à payer",
	'404' => "Fournisseurs d’immobilisations",
	'4041' => "Fournisseurs – Achats d’immobilisations",
	'4047' => "Fournisseurs d’immobilisations – Retenues de garantie",
	'405' => "Fournisseurs d’immobilisation – Effets à payer", // Y compris billets de fonds.
	'408' => "Fournisseurs – Factures non parvenues",
	'4081' => "Fournisseurs – Achats de biens ou de prestations de services",
	'4084' => "Fournisseurs – Achats d’immobilisations",
	'4088' => "Fournisseurs – Intérêts courus",
	'409' => "Fournisseurs débiteurs",
	'4091' => "Fournisseurs – Avances et acomptes versés sur commandes",
	'4096' => "Fournisseurs – Créances pour emballage et matériel à rendre",
	'4098' => "Rabais, remises, ristournes à obtenir et autres avoirs non encore reçus",
	'41' => "Usagers/Clients et comptes rattachés", // Les comptes de base (sur trois chiffres) peuvent être subdivisé à l’initiative des organismes pour distinguer les opérations faites et France ou à l’Étranger, en Euros ou en devises, et selon qu’elles sont traitées à long/moyen/court terme.
	'410' => "Usagers/Clients et comptes rattachés",
	'411' => "Usagers/Clients (et organismes de prise en charge)", // (factures de créances)
	'4111' => "– Ventes de biens ou de prestations de services",
	'4117' => "– Retenues de garantie",
	'413' => "Usagers/Clients – Effets à recevoir",
#	'416' => "Usagers/Clients – Créances douteuses ou litigieuses", // (Supprimé par le règlement n°99-08 du CRC)
#	'417' => "", // compte supprimé
	'418' => "Usagers/Clients – Produits non encore facturés",
	'4181' => "Usagers/Clients – Factures à établir",
	'4188' => "Usagers/Clients – Intérêts courus",
	'419' => "Usagers/Clients créditeurs",
	'4191' => "Usagers/Clients – Avances et acomptes reçus sur commandes",
	'4196' => "Usagers/Clients – Dettes pour emballages et matériels consignés",
	'4197' => "Usagers/Clients – Autres avoirs",
	'4198' => "Rabais, remises, ristournes à accorder et autres avoirs à établir",
	'42' => "Personnel et comptes rattachés",
	'421' => "Personnel – Rémunérations dues",
	'422' => "Comités d’entreprise, d’établissement, …",
	'423' => "Notes de frais", // (compte non indiqué dans le PCG, c'est un compte issu de la pratique)
	'424' => "Participations des salariés aux résultats",
	'4246' => "Réserve spéciale", // (art. L. 442-2 du Code du travail)
	'4248' => "Compte courants",
	'425' => "Personnel – Avances et acomptes",
	'426' => "Personnel – Dépôts",
	'427' => "Personnel – Oppositions",
	'428' => "Personnel – Charges à payer et produits à recevoir",
	'4282' => "Dettes provisionnées pour congés à payer",
	'4284' => "Dettes provisionnées pour participation des salariés aux résultats",
	'4286' => "Autres charges à payer",
	'4287' => "Produits à recevoir",
	'43' => "Sécurité sociale et autres organismes sociaux",
	'431' => "sécurité sociale", // MSA salariés
	'437' => "Autres organismes sociaux",
	'4372' => "Mutuelles",
	'4373' => "Caisses de retraites et de prévoyance",
	'4374' => "Caisse d’allocations de chômage – ASSEDIC",
	'4378' => "Autres organismes sociaux – Divers",
	'438' => "Organismes sociaux – Charges à payer et produits à recevoir",
	'4382' => "Charges sociales sur congés à payer",
	'4386' => "Autres charges à payer",
	'4387' => "Produits à recevoir",
	'44' => "État et autres collectivités publiques",
	'441' => "État – Subventions à recevoir",
	'4411' => "Subventions d’investissement",
	'4417' => "Subventions d’exploitation",
	'4418' => "Subventions d’équilibre",
	'4419' => "Avances sur subventions",
	'442' => "État – Impôts et taxes recouvrables sur des tiers",
	'4424' => "Obligataires",
	'4425' => "Associés",
	'443' => "Opérations particulières avec l’État, les collectivités publiques, les organismes internationaux",
	'4431' => "Créances sur l’État résultant de la suppression de la règle du décalage d’un mois en matière de TVA",
	'4438' => "Intérêts courus sur créances figurant au compte 4431",
	'444' => "État – Impôts sur les bénéfices",
	'4445' => "État – Impôt sur les organismes", // (avec ou sans but lucratif)
	'445' => "État – Taxes sur le chiffre d’affaires",
	'4452' => "TVA due intracommunautaire",
	'4455' => "Taxes sur le chiffre d’affaires à décaisser",
	'44551' => "TVA à décaisser",
	'44558' => "Taxes assimilées à la TVA",
	'4456' => "Taxes sur le chiffre d’affaires déductibles",
	'44562' => "TVA (déductible) sur immobilisations",
	'44563' => "TVA (déductible) transférérée par d’autres entreprises",
	'44565' => "TVA à régulariser sur achats",
	'44566' => "TVA (déductible) sur autres biens et services",
	'44567' => "Crédit de TVA à reporter (déductible)",
	'44568' => "Taxes assimilées à la TVA",
	'4457' => "Taxes sur le chiffre d’affaires collectées par l’entreprise",
	'44571' => "TVA collectée",
	'44575' => "TVA à régulariser sur ventes",
	'44578' => "Taxes assimilées à la TVA",
	'4458' => "Taxes sur le chiffre d’affaires à régulariser ou en attente",
	'44581' => "Acomptes – Régime simplifié d’imposition",
	'44582' => "Acomptes – Régime du forfait",
	'44583' => "Remboursement de taxes sur le chiffre d’affaires demandé",
	'44584' => "TVA récupérée d’avance",
	'44586' => "Taxes sur le chiffre d’affaires sur factures non parvenues",
	'44587' => "Taxes sur le chiffre d’affaires sur factures à établir", // Ce compte est utilisé lorsque l’exigibilité des taxes n’est pas encore intervenue.
	'446' => "Obligations cautionnées",
	'447' => "Autres impôts, taxes et versements assimilés",
	'4471' => "Impôts, taxes et versements assimilés sur rémunérations (administration des impôts)",
	'44711' => "Taxe sur les salaires",
	'44713' => "Participation des employeurs à la formation professionnelle continue",
	'44714' => "Cotisation pour défaut d’investissement obligatoire dans la construction",
	'44718' => "Autres impôts, taxes et versements assimilés",
	'4473' => "Impôts, taxes et versements assimilés sur rémunérations (autres organismes)",
	'44733' => "Participation des employeurs à la formation professionnelle continue",
	'44734' => "Participation des employeurs à l’effort de construction (versements à fonds perdu)",
	'4475' => "Autres impôts, taxes et versements assimilés (administration des impôts)",
	'4477' => "Autres impôts, taxes et versements assimilés (autres organismes)",
	'448' => "État – Charges à payer et produits à recevoir",
	'4482' => "Charges fiscales sur congés à payés",
	'4486' => "Autres charges à payer",
	'4487' => "Produits à recevoir",
	'449' => "Quotas d’émission à restituer à l’État",
	'45' => "Confédération, fédération, union,  associations affiliées",
	'451' => "Groupe, confédération, fédération, associations affiliées – Compte courant",
	'455' => "Sociétaires – Comptes courants",
	'4551' => "Principal",
	'45511' => "Compte courant d’associés 1",
	'45512' => "Compte courant d’associés 2",
	'45513' => "Compte courant d’associés 3",
	'45514' => "Compte courant d’associés 4",
	'4558' => "Intérêts courus",
	'456' => "Associés – Opérations sur le capital",
	'4561' => "Associés – Comptes d’apport en société",
	'45611' => "Apports en nature",
	'45615' => "Apports en numéraire",
	'4562' => "Apporteurs – Capital appelé non versé",
	'45621' => "Actionnaires – Capital souscrit et appelé, non versé",
	'45625' => "Associés – Capital appelé, non versé",
	'4563' => "Associés – Versements reçus sur augmentation de capital",
	'4564' => "Associés – Versements anticipés",
	'4566' => "Actionnaires défaillants",
	'4567' => "Associés – Capital à rembourser",
	'457' => "Associés – Dividendes à payer",
	'458' => "Associés – Opérations faites en commun et en G.I.E.",
	'4581' => "Opérations courantes",
	'4588' => "Intérêts courus",
	'46' => "Débiteurs divers et créditeurs divers",
	'462' => "Créances sur cessions d’immobilisations", // Y compris billets de fonds.
	'464' => "Dettes sur acquisitions de valeurs mobilières de placement",
	'465' => "Créances sur cessions de valeurs mobilières de placement",
	'467' => "Autres comptes débiteurs ou créditeurs",
	'468' => "Divers – Charges à payer et produits à recevoir",
	'4686' => "Charges à payer",
	'4687' => "Produits à recevoir",
	'47' => "Comptes d’attente", // Sauf impossibilité, les opérations inscrites dans ces comptes sont reclassées en fin d’exercice parmi les comptes figurant au modèle de bilan.
	'471' => "Recettes à classer",
	'472' => "Dépenses à classer et à régulariser",
	'475' => "Legs et donations en cours de réalisation",
	'476' => "Différence de conversion – Actif",
	'4761' => "Diminution des créances",
	'4762' => "Augmentation des dettes",
	'4768' => "Différences compensées par couverture de change",
	'477' => "Différences de conversion – Passif",
	'4771' => "Augmentation des créances",
	'4772' => "Diminution des dettes",
	'4778' => "Différences compensées par couverture de change",
	'478' => "Autres comptes transitoires",
	'48' => "Comptes de régularisation",
	'481' => "Charges à répartir sur plusieurs exercices", // (Règlement n°2004-06 du CRC)
#	'4811' => "Charges différéess", // compte supprimé
#	'4812' => "Frais d’acquisition des immobilisations", // compte supprimé
	'4816' => "Frais d’émission des emprunts",
	'4817' => "Pénalités de négociation de la dette",
#	'4818' => "Charges différées liées à l’obligation d’équilibre budgétaire", //= Charges à étaler. compte supprimé
	'486' => "Charges constatée d’avance",
	'487' => "Produits constatés d’avance",
	'488' => "Comptes de répartition périodique des charges et des produits",
	'4886' => "Charges",
	'4887' => "Produits",
	'489' => "Quotas d’émission alloués par l’État",
	'49' => "Provision pour dépréciation des comptes de tiers",
	'491' => "Provisions pour dépréciation des comptes d’usagers/clients (et organismes de prise en charge)",
	'495' => "Dépréciations des comptes du groupe et des associés",
	'4951' => "Comptes du groupe",
	'4955' => "Comptes courants des associés",
	'4958' => "Opérations faites en commun et en GIE",
	'496' => "Provision pour dépréciation des comptes de débiteurs divers",
	'4962' => "Créances sur cessions d’immobilisations",
	'4965' => "Créances sur cessions de valeurs mobilières de placement",
	'4967' => "Autres comptes débiteurs",

	'5' => "Comptes financiers",
	'50' => "Valeurs mobilières de placement", // Les comptes de base (sur trois chiffres) peuvent être subdivisé à l’initiative des organismes pour distinguer les opérations faites et France ou à l’Étranger, en Euros ou en devises, et selon qu’elles sont traitées à long/moyen/court terme.
	'501' => "Parts dans des entreprises liées",
	'502' => "Actions propres",
	'503' => "Actions",
	'5031' => "Titres cotés",
	'5035' => "Titres non cotés",
	'504' => "Autres titres conférant un droit de propriété",
	'505' => "Obligations et bons émis par l’organisme et rachetés par elle",
	'506' => "Obligations",
	'5061' => "Obligations cotées",
	'5065' => "Obligations non cotées",
	'507' => "Bons du Trésor et bons de caisse à court terme",
	'508' => "Autres valeurs mobilières et créances assimilées",
	'5081' => "Autres valeurs mobilières",
	'5082' => "Bons de souscription",
	'5088' => "Intérêts courus sur obligations, bons et valeurs assimilées",
	'509' => "Versements restant à effectuer sur valeurs mobilières de placement non libérées",
	'51' => "Banques, établissements financiers et assimilés",
	'511' => "Valeurs à l’encaissement",
	'5111' => "Coupons échus à l’encaissement",
	'5112' => "Chèques à encaisser",
	'5113' => "Effets à l’encaissement",
	'5114' => "Effets à l’escompte",
	'512' => "Banques",
	'5121' => "Comptes en monnaie nationale",
	'5124' => "Comptes en devises",
	'513' => "Caisse des dépôts et consignations",
	'514' => "Chèques postaux",
	'515' => "«Caisses» du Trésor et des établissements publics",
	'516' => "Sociétés de bourse, Agents de change", // (loi du 22 janvier 1988)
	'517' => "Autres organismes financiers",
	'5171' => "Caisse d’Épargne",
	'518' => "Intérêts courus",
	'5186' => "Intérêts courus à payer",
	'5187' => "Intérêts courus à recevoir",
	'519' => "Concours bancaires/financiers courants", // Autre que ceux directement enregistrés dans les comptes 512 à 518.
	'5191' => "Crédit de mobilisation de créances commerciales (CMCC)",
	'5193' => "Mobilisation de créances nées à l’étranger",
	'5198' => "Intérêts courus sur concours bancaires courants",
	'52' => "Instruments de trésorerie",
	'53' => "Caisse",
	'531' => "Caisse du siège social",
	'5311' => "Caisse en monnaie nationale",
	'5314' => "Caisse en devise",
	'532' => "Caisse des lieux d’activités A", //= "Caisse succursale (ou usine) A"
	'533' => "Caisse des lieux d’activités B", // "Caisse succursale (ou usine) B"
	'54' => "Régies d’avances et accréditifs",
	'541' => "Régies d’avances",
	'542' => "Accréditifs",
	'58' => "Virements internes",
	'581' => "Virements de fonds",
	'59' => "Provisions pour dépréciation des comptes financiers",
	'590' => "Provisions pour dépréciation des valeurs mobilières de placement",
	'5903' => "Actions",
	'5904' => "Autres titres conférant un droit de propriété",
	'5906' => "Obligations",
	'5908' => "Autres valeurs mobilières de placement et créances assimilées",

	'6' =>"Comptes de charges",
	'60' => "Achats (sauf 603)",
	'601' => "Achats stockés – Matières premières et fournitures", // Structure laissée libre en vue de répondre à la diversité des actions entreprises par le secteur associatif.
	'6011' => "Matières (ou groupe) A", // Ex. : Achat engrais et amendements
	'6012' => "Matières (ou groupe) B", // Ex. : Achat de semences
	'6013' => "Matières (ou groupe) C", // Ex. : Produits de défense des animaux
	'6014' => "Matières (ou groupe) D", // Ex. : Achat d’aliments
	'6015' => "Matières (ou groupe) E", // Ex. : Produits véto
	'6016' => "Matières (ou groupe) F", // Ex. : Produits de reproduction animale
	'6017' => "Fournitures A", // Ex. : Achat d’emballages
	'6018' => "Fournitures B", // Ex. : Achat combustibles
	'6019' => "Fournitures C…",
	'602' => "Achats stockés – Autres approvisionnements", // Structure laissée libre en vue de répondre à la diversité des actions entreprises par le secteur associatif.
	'6021' => "Matières consommables", // Ex. : Achat carburants et lubrifiants. Les organismes pour lesquels la distinction entre "Matières consommables" et "Fournitures consommables" n'est pas indispensable peuvent regrouper les comptes 6021 et 6022 sous le numéro 6021 dont l’intitulé est complété en conséquence : "Achat de matières et fournitures consommables".
	'60211' => "Matières (ou groupe) C", // Ex. : Achat de fuel
	'60212' => "Matières (ou groupe) D", // Ex. : Achat d’huile et de graisse
	'6022' => "Fournitures consommables", // Les organismes pour lesquels la distinction entre "Matières consommables" et "Fournitures consommables" n'est pas indispensable peuvent regrouper les comptes 6021 et 6022 sous le numéro 6021 dont l’intitulé est complété en conséquence : "Achat de matières et fournitures consommables".
	'60221' => "Combustibles",
	'60222' => "Produits d’entretien", // (produits de lavage)
	'60223' => "Fournitures d’atelier et d’usine",
	'60224' => "Fournitures de magasin",
	'60225' => "Fournitures de bureau",
#?	'6024' => "Fournitures de bureau stockables",
	'6026' => "Emballages",
	'60261' => "Emballages perdus",
	'60265' => "Emballages récupérables non identifiables",
	'60267' => "Emballages à usage mixte",
	'6027' => "Fournitures de structure (vêtement de travail)",
	'60271' => "Fournitures type 1", // végétaux (ficelle, bâche)
	'60272' => "Fournitures type 2", // animaux (boucles, pinces, cordes)
	'603' => "Variation des stocks (approvisionnement et marchandises)",
	'6031' => "Variation des stocks de matières premières et fournitures",
	'6032' => "Variation des stocks des autres approvisionnements",
	'6037' => "Variation des stocks de marchandises",
	'604' => "Achats d’études et prestations de services", // Incorporés directement aux produits et prestations de service.
	'6051' => "Travaux par tiers", // Ex. : Productions végétales (moissons, ensilages)
	'6054' => "Frais par tiers", // Ex. : Frais d’élevage ou d’insémination
	'606' => "Achats non stockés de matières et fournitures", // Structure laissée libre en vue de répondre à la diversité des actions entreprises par le secteur associatif.
	'6061' => "Fournitures non stockables (eau, énergie, …)",
	'6063' => "Fournitures d’entretiens et de petit équipement", // Matières et fournitures qui ne passent pas par un compte en magasin.
	'6064' => "Fournitures administratives", // Ex. Carburant à la pompe (véhicules exploitation).  Matières et fournitures qui ne passent pas par un compte en magasin.
#	'6066' => "Fournitures d’entretiens et de petit équipement",
	'6067' => "Fournitures LSM",
	'6068' => "Autres matières et fournitures de bureau", // Matières et fournitures qui ne passent pas par un compte en magasin.
	'607' => "Achats de marchandises",
	'6071' => "Marchandises (ou groupe) A",
	'6072' => "Marchandises (ou groupe) B",
#	'608' => "", // Compte réservé, le cas échéant, à la récapitulation des frais accessoires incorporés aux achats
	'609' => "Rabais, remises et ristournes obtenues sur achats",
	'6091' => "– de matières premières (et fournitures)",
	'6092' => "– d’autres approvisionnements stockés",
	'6094' => "– d’études et de prestations de services",
	'6095' => "– de matériel, équipements et travaux",
	'6096' => "– d’approvisionnements non stockés",
	'6097' => "– de marchandises",
	'6098' => "Rabais, remises et ristournes non affectés",
	'61' => "Services extérieurs",
	'611' => "Sous-traitance générale", // Autre que sous-traitance incorporée directement aux ouvrages, travaux et produits fabriqués, et inscrite au compte 604 ou 605.
	'612' => "Redevances de crédit-bail",
	'6122' => "Crédit-bail immobilier",
	'6125' => "Crédit-bail mobilier",
	'613' => "Locations",
	'6132' => "Locations immobilières", // Loyer, fermages
	'6135' => "Locations mobilières", // Location de matériel
	'6136' => "Malis sur les emballages",
	'614' => "Charges locatives et de copropriété", // Lorsque le montant des charges de copropriété n’a pas un caractère significatif justifiant leur ventilation dans les autres comptes par nature.
	'615' => "Entretiens et réparations",
	'6151' => "Entretiens des terrains", // Ex. : barbelés et grillage.
	'6152' => "Entretiens et réparations sur biens immobiliers",
#	'6153' => "Entretiens et réparations des constructions",
	'6155' => "Entretiens et réparations sur biens mobiliers",
	'61551' => "Entretien des installations complexes",
	'6156' => "Maintenance du matériel",
	'616' => "Primes d’assurance", // (exploitation)
	'6161' => "Multirisques",
	'6162' => "Assurance obligatoire dommage-construction",
	'6163' => "Assurance-transport",
	'61636' => "– sur achats",
	'61637' => "– sur ventes",
	'61638' => "– sur autres biens",
	'6164' => "Risques d’exploitation",
	'6165' => "Insolvabilité clients",
	'6168' => "Autres assurances",
	'617' => "Études et recherches", // Ex. : analyse de terre.
	'618' => "Divers",
	'6181' => "Documentation générale", // (abonnement)
	'6183' => "Documentation technique", // (abonnement)
	'6185' => "Frais de colloques, séminaires, conférences",
	'619' => "Rabais, remises, ristournes obtenus sur services extérieurs",
	'62' => "Autres services extérieurs",
	'621' => "Personnel extérieur à l’organisme",
	'6211' => "Personnel intérimaire",
	'6214' => "Personnel détaché ou prêté à l’organisme", // Groupement d’employeurs
	'622' => "Rémunérations d’intermédiaires et honoraires", // Commission sur vente
	'6221' => "Commissions et courtages sur achats",
	'6222' => "Commissions et courtages sur ventes",
	'6224' => "Rémunérations des transitaires",
	'6225' => "Rémunérations d’affacturage", // Ex. : Honoraires véto
	'6226' => "Autres honoraires", // Ex. : notaires, avocats, comptabilité.
	'62266' => "Maintenace de logiciel",
	'6227' => "Frais d’actes et de contentieux",
	'6228' => "Divers",
	'623' => "Publicité, publications, relations publiques",
	'6231' => "Annonces et insertions",
	'6232' => "Échantillons",
	'6233' => "Foires et expositions",
	'6234' => "Cadeaux à la clientèle",
	'6235' => "Primes",
	'6236' => "Catalogues et imprimés",
	'6237' => "Publications",
	'6238' => "Divers (pourboires, dons courants, …)",
	'624' => "Transports de biens et transports collectifs du personnel",
	'6241' => "Transports sur achats",
	'6242' => "Transports sur ventes",
	'6243' => "Transports entre établissements ou chantiers",
	'6244' => "Transports administratifs",
	'6247' => "Transports collectifs du personnel",
	'6248' => "Divers",
	'625' => "Déplacements, missions et réceptions",
	'6251' => "Voyages et déplacements",
	'6256' => "Missions",
	'6257' => "Réceptions",
	'626' => "Frais postaux et frais de télécommunications",
	'6261' => "Frais postaux",
	'627' => "Services bancaires et assimilés",
	'6271' => "Frais de tenu du compte bancaire", //ex Frais sur titres (achat, vente, garde)
	'6272' => "Commissions et frais sur émission d’emprunts",
	'6275' => "Frais sur effets", // (commission d'endossement, …)
	'6276' => "Location de coffres",
	'6278' => "Autres frais et commissions sur prestations de services",
	'628' => "Divers",
	'6281' => "Cotisations (liées à l’activité économique)", //= "Concours divers (cotisations professionnelles…)"
	'6284' => "Frais de recrutement du personnel",
	'629' => "Rabais, remises et ristournes obtenus sur autres services extérieurs",
	'63' => "Impôts, taxes et versements assimilés",
	'631' => "Impôts, taxes et versements assimilés sur rémunérations (administration des impôts)",
	'6311' => "Taxe sur salaires",
	'6312' => "Taxe d’apprentissage",
	'6313' => "Participation des employeurs à la formation professionnelle continue",
	'6314' => "Cotisation pour défaut d’investissement obligatoire dans la construction",
	'6318' => "Autres",
	'633' => "Impôts, taxes et versements assimilés sur rémunérations (autres organismes)",
	'6331' => "Versement de transport",
	'6332' => "Allocations logement",
	'6333' => "Participation des employeurs à la formation professionnelle continue",
	'6334' => "Participation des employeurs à l’effort de construction (versement à fonds perdu)",
	'6335' => "Versements libératoires ouvrant droit à l’exonération de la taxe d’apprentissage",
	'6338' => "Autres",
	'634' => "Taxes ANDA",
	'6341' => "Taxes sur produits végétaux", // (taxes sur céréales)
	'6342' => "Taxes sur produits animaux", // (taxes sur le lait)
	'6344' => "Taxes sur animaux",
	'63441' => "Taxes sur animauX SFP", // (bovins, ovins)
	'63442' => "Taxes sur animaux hors sol", // (porc, lapin)
	'635' => "Autres impôts, taxes et versements assimilés (administration des impôts)",
	'6351' => "Impôts directs", // (sauf impôts sur les bénéfices)
	'63511' => "Taxe professionnelle",
	'63512' => "Taxes foncières",
	'63513' => "Autres impôts locaux",
	'63514' => "Taxe sur les véhicules de sociétés",
	'63518' => "Autres impôts directs",
	'6352' => "Taxes sur le chiffre d'affaire non recuperables ", // Les organismes tiennent ce compte lorsqu’ils n’ont pu exceptionnellement enregistrer leurs charges, TVA non récupérable comprise (en cas de régularisation difficilement rattachables à une charge déterminée).
	'6353' => "Impôts indirects",
	'6354' => "Droits d’enregistrement et de timbre",
	'63541' => "Droits de mutation",
	'6357' => "Droits d’enregistrement et de timbres",
	'6358' => "Autres droits",
	'637' => "Autres impôts, taxes et versements assimilés (autres organismes)",
	'6371' => "Contribution sociale de solidarité à la charge des organismes",
	'6372' => "Taxes perçues par les organismes publics internationaux",
	'6374' => "Impôts et taxes exigibles à l’Étranger",
	'6378' => "Taxes diverses",
	'64' => "Charges de personnel",
	'641' => "Rémunérations du personnel", // Y compris gérance majoritaire et administrateurs de sociétés.
	'6411' => "Salaires, appointements, commissions de base",
	'6412' => "Congés payés",
	'6413' => "Primes et gratifications", // et Rémunération des associés
	'6414' => "Indemnités et avantages divers",
	'6415' => "Supplément familial",
	'6418' => "Avantages en nature",
	'644' => "Rémunération du travail de l’exploitant", // Compte à utiliser dans les entreprises individuelles conformément aux dispositions en vigueur.
	'645' => "Charges de sécurité sociale et de prévoyance",
	'6451' => "Cotisations à l’URSSAF",
	'6452' => "Cotisations aux mutuelles",
	'6453' => "Cotisations aux caisses de retraites et de prévoyance",
	'6454' => "Cotisations aux ASSEDIC",
	'6458' => "Cotisations aux autres organismes sociaux", // (MSA)
	'646' => "Cotisations sociales personnelles de l’exploitant", // (MSA, GAMEX)
	'647' => "Autres charges sociales",
	'6471' => "Prestations directes",
	'6472' => "Versements aux comités d’entreprise et d’établissement",
	'6473' => "Versements aux comités d’hygiène et de sécurité",
	'6474' => "Versements aux autres œuvres sociales",
	'6475' => "Médecine du travail, pharmacie",
	'648' => "Autres charges de personnel", // Ex. : stagiaires.
	'65' => "Autres charges de gestion courante",
	'651' => "Redevances pour concessions, brevets, licences, marques, procédés, droits et valeurs similaires",
	'6511' => "Redevances pour concessions, brevets, licences, marques, procédés",
	'6516' => "Droits d’auteur et de reproduction (SACEM)",
	'6518' => "Autres droits et valeurs similaires",
	'653' => "Jetons de présence",
	'654' => "Pertes sur créances irrécouvrables",
	'6541' => "Créances de l’exercice",
	'6544' => "Créances des exercices antérieurs",
	'655' => "Quotes-parts de résultat sur opérations faites en commun",
	'6551' => "Quote-part de bénéfice transférée (comptabilité du gérant)",
	'6555' => "Quote-part de perte supportée (comptabilité des associés non gérants)",
	'6556' => "Frais de siège versés",
	'657' => "Subventions versées par l’organisme",
	'6571' => "Bourses accordées aux usagers",
	'658' => "Charges diverses de gestion courante",
	'6586' => "Cotisations (liées à la vie statutaire)",
	'6588' => "Autres charges liées aux missions sociales",
	'66' => "Charges financières",
	'661' => "Charges d’intérêts", // (capital : 164)
	'6611' => "Intérêts des emprunts et dettes", // (capital : 1641)
	'66116' => "– des emprunts et dettes assimilées",
	'66117' => "– des dettes rattachées à des participations",
	'6612' => "Intérêt des emprunts à moyen et court terme", // (capital : 1642)
	'6613' => "Intérêt des emprunts à long terme", // (capital : 1643 ou 5191)
	'6614' => "Crédit de campagne",
	'6615' => "Intérêts des comptes courants et des dépôts créditeurs",
	'6616' => "Intérêts bancaires", // et sur opérations de financement (escompte)
	'6617' => "Intérêts des obligations cautionnées",
	'6618' => "Intérêts des autres dettes", // (fournisseurs et autres ouvertures de crédit)
	'66181' => "– des dettes commerciales",
	'66188' => "– des dettes diverses",
	'664' => "Pertes sur créances liées à des participations",
	'665' => "Escomptes accordés",
	'666' => "Pertes de change",
	'667' => "Charges nettes sur cessions de valeurs mobilières de placement",
	'668' => "Autres charges financières",
	'67' => "Charges exceptionnelles",
	'671' => "Charges exceptionnelles sur opérations de gestion",
	'6711' => "Pénalités sur marchés (et dédits payés sur achats et ventes)",
	'6712' => "Pénalités et amendes fiscales ou pénales",
	'6713' => "Dons, libéralités",
	'6714' => "Créances devenues irrécouvrables dans l’exercice",
	'6715' => "Subventions accordées",
	'6717' => "Rappel d’impôts (autres qu’impôts sur les bénéfices)",
	'6718' => "Autres charges exceptionnelles sur opérations de gestion",
	'672' => "Charges sur exercices antérieurs (à reclasser)", // Compte à la disposition des organismes pour enregistrer, en cours d’exercice, les charges sur les exercices antérieurs,
	'675' => "Valeurs comptables des éléments d’actif cédés",
	'6751' => "Immobilisations incorporelles",
	'6752' => "Immobilisations corporelles",
	'6756' => "Immobilisations financières",
	'6758' => "Autres éléments d’actif", // Sauf stocks et valeurs mobilières de placement.
	'678' => "Autres charges exceptionnelles",
	'6781' => "Malis provenant de clauses d’indexation",
	'6782' => "Lots",
	'6783' => "Malis provenant du rachat par l’entreprise d’actions et obligations émises par elle-même",
	'6788' => "Charges exceptionnelles diverses",
	'68' => "Dotations aux amortissements, provisions et engagements",
	'681' => "Dotations aux amortissements et aux provisions – Charges d’exploitation",
	'6811' => "Dotations aux amortissements des immobilisations incorporelles et corporelles",
	'68111' => "Immobilisations incorporelles",
	'68112' => "Immobilisations corporelles",
	'6812' => "Dotations aux amortissements des charges d’exploitation à répartir",
	'6815' => "Dotations aux provisions pour risques et charges d’exploitation",
	'6816' => "Dotation aux provisions pour dépréciation des immobilisations incorporelles et corporelles",
	'68161' => "Immobilisations incorporelles",
	'68162' => "Immobilisations corporelles",
	'6817' => "Dotations aux provisions pour dépréciation des actifs circulants", // Autres que valeurs mobilières de placement.
	'68173' => "Stocks et en-cours",
	'68174' => "Créances",
	'686' => "Dotations aux amortissements et aux provisions – Charges financières",
	'6861' => "Dotation aux amortissements des primes de remboursement des obligations",
	'6865' => "Dotation aux provisions pour risques et charges financiers",
	'6866' => "Dotations aux provisions pour dépréciation des éléments financiers",
	'68662' => "Dotations aux provisions financières",
	'68665' => "Valeurs mobilières de placement",
	'6868' => "Autres dotations",
	'687' => "Dotations aux amortissements et aux provisions – Charges exceptionnelles",
	'6871' => "Dotations aux amortissements exceptionnels des immobilisations",
	'6872' => "Dotations aux provisions réglementées (immobilisations)",
	'68725' => "Dotations aux amortissements dérogatoires",
	'6873' => "Dotations aux provisions réglementées (stocks)",
	'68735' => "Amortissements dérogatoires",
	'6874' => "Dotations aux autres provisions réglementées",
	'6875' => "Dotations aux provisions exceptionnelles",
	'6876' => "Dotations aux provisions pour dépréciations exceptionnelles",
	'689' => "Engagements à réaliser sur ressources affectées",
	'6893' => "Engagements à réaliser des fondations abritées",
	'6984' => "Engagements à réaliser sur subvention attribuées",
	'6895' => "Engagements à réaliser sur dons manuels affectés",
	'6897' => "Engagements à réaliser sur legs et donations afffectés",
	'69' => "Impôts sur les bénéfices et assimilés & Participation des salariés",
	'691' => "Participation des salariés aux résultats",
	'695' => "Impôts sur les organismes", // des personnes morales lucratives ou pas…
	'6951' => "Impôts dus en France",
	'6952' => "Contribution additionnelle à l’impôt sur les bénéfices",
	'6954' => "Impôts dus à l’Étranger",
	'696' => "Suppléments d’impôt sur les organismes, liés aux distributions",
#	'697' => "Imposition forfaitaire annuelle des organismes", // Avant 1996, depuis compte 635.
	'698' => "Intégration fiscale",
	'6981' => "Intégration fiscale. Charges",
	'6989' => "Intégration fiscale. Produits",
	'699' => "Produits – Reports en arrière des déficits", // ?

	'7' => "Comptes de produits",
	'70' => "Ventes de produits finis, prestations de services, marchandises", // Les comptes de base (sur trois chiffres) peuvent être subdivisé pour distinguer les ventes faites et France ou à l’Étranger.
	'701' => "Ventes de produits finis", // Les organismes pour lesquels la distinction des "Ventes de produits finis" et des "Ventes de produits intermédiaires" n'est pas significative peuvent regrouper les comptes 701 et 702 dans le numéro 701 dont l’intitulé devient : "Ventes de produits finis et intermédiaires".
	'7011' => "Produits finis (ou groupe) A",
	'7012' => "Produits finis (ou groupe) B",
	'702' => "Ventes de produits intermédiaires", // Les organismes pour lesquels la distinction des "Ventes de produits finis" et des "Ventes de produits intermédiaires" n'est pas significative peuvent regrouper les comptes 701 et 702 dans le numéro 701 dont l’intitulé devient : "Ventes de produits finis et intermédiaires".
	'703' => "Ventes de produits résiduels",
	'704' => "Travaux", // Les organismes relevant du systeme abrege regroupent les comptes 704 et 705 et 706 sous le numéro 706 dont l’intitulé devient : "Travaux et prestations de services".
	'7041' => "Travaux de catégorie (ou activité) A",
	'7042' => "Travaux de catégorie (ou activité) B",
	'705' => "Études", // Les organismes relevant du systeme abrege regroupent les comptes 704 et 705 et 706 sous le numéro 706 dont l’intitulé devient : "Travaux et prestations de services".
	'706' => "Prestations de services", // Les organismes relevant du systeme abrege regroupent les comptes 704 et 705 et 706 sous le numéro 706 dont l’intitulé devient : "Travaux et prestations de services".
	'707' => "Ventes de marchandises",
	'7071' => "Marchandises (ou groupe) A",
	'7072' => "Marchandises (ou groupe) B",
	'708' => "Produits des activités annexes",
	'7081' => "Produits des prestations fournies au personnel", //= "Produits des services exploités dans l'intérêt du personnel".
	'7082' => "Commissions et courtages",
	'7083' => "Locations diverses",
	'7084' => "Mise à disposition de personnel facturée",
	'7085' => "Ports et frais accessoires facturés",
	'7086' => "Bonis sur reprises d’emballages consignés",
	'7087' => "Bonifications obtenues des clients et primes sur ventes",
	'7088' => "Autres produits d’activités annexes", // (cessions d’approvisionnements…)
	'709' => "Rabais, remises et ristournes accordées par l’organisme",
	'7091' => "– sur ventes de produits finis",
	'7092' => "– sur ventes de produits intermédiaires",
	'7094' => "– sur travaux",
	'7095' => "– sur études",
	'7096' => "– sur prestations de services",
	'7097' => "– sur ventes de marchandises",
	'7098' => "– sur produits des activités annexes",
	'71' => "Production stockée (ou déstockage)",
	'713' => "Variation des stocks (en-cours de production, produits)",
	'7133' => "Variation des en-cours de production de biens",
	'71331' => "Produits en cours",
	'71335' => "Travaux en cours",
	'7134' => "Variation des en-cours de production de services",
	'71341' => "Études en cours",
	'71345' => "Prestations de services en cours",
	'7135' => "Variation des stocks de produits",
	'71351' => "Produits intermédiaires",
	'71355' => "Produits finis",
	'71358' => "Produits résiduels",
	'72' => "Production immobilisée",
	'720' => "Report exercice précédent",
	'721' => "Immobilisations incorporelles",
	'722' => "Immobilisations corporelles",
#	'73' => "Produits nets partiels sur opérations à long terme", // compte supprimé
#	'731' => "Produits nets partiels sur opérations en cours", // à subdiviser par operation : compte supprimé
#	'739' => "Produits nets partiels sur opérations terminées", // compte supprimé
	'74' => "Subvention d’exploitation",
	'740' => "Subvention municipale",
	'741' => "Subvention départementale",
	'742' => "Subvention régionale",
	'75' => "Autres produits de gestion courante",
	'751' => "Redevances pour concessions, brevets, licences, marques, procédés, droits et valeurs similaires",
	'7511' => "Redevances pour concessions, brevets, licences, marques, procédés, logiciels",
	'7516' => "Droits d’auteur et de reproduction",
	'7518' => "Autres droits et valeurs similaires",
	'752' => "Revenus des immeubles non affectés à des activités professionnelles",
	'753' => "Jetons de présence et rémunérations d’administrateurs, gérants",
	'754' => "Collectes & Ristournes perçues des coopératives (provenant des excédents)",
	'755' => "Quotes-parts de résultat sur opérations faites en commun",
	'7551' => "Quote-part de perte transférée (comptabilité du gérant)",
	'7555' => "Quote-part de bénéfice attribuée (comptabilité des associés non gérants)",
	'756' => "Cotisations",
	'757' => "Quote-part d’éléments du fonds associatif virée au compte de résultat",
	'7571' => "Quote-part de subventions d’investissement (renouvelables) virée au compte de résultat",
	'7573' => "Quote-part des apports virée au compte de résultat",
	'758' => "Produits divers de gestion courante",
	'7581' => "Dons manuels non affectés",
	'7582' => "Dons manuels affectés",
	'7585' => "Legs et donations non affectés",
	'7586' => "Legs et donations affectés",
	'7587' => "Vente de dons en nature",
	'7588' => "Autres produits de la générosité du public",
	'76' => "Produits financiers",
	'761' => "Produits des participations",
	'7611' => "Revenus des titres de participations",
	'7616' => "Revenus sur autres formes de participation",
	'7617' => "Revenus des créances rattachées à des participations",
	'762' => "Produits des autres immobilisations financières",
	'7621' => "Revenus des titres immobilisés",
#	'7624' => "Revenus des prêts", // compte supprimé (remplacé par 7626)
	'7626' => "Revenus des prêts",
	'7627' => "Revenus des créances diverses",
	'763' => "Revenus des autres créances",
	'7631' => "Revenus des créances commerciales",
	'7638' => "Revenus des créances diverses",
	'764' => "Revenus des valeurs mobilières de placement",
	'765' => "Escomptes obtenus",
	'766' => "Gains de change",
	'767' => "Produits nets sur cessions de valeurs mobilières de placement",
	'768' => "Autres produits financiers",
	'7681' => "Intérêts des comptes financiers débiteurs",
	'77' => "Produits exceptionnels",
	'771' => "Produits exceptionnels sur opérations de gestion",
	'7711' => "Dédits et pénalités perçus sur achats et sur ventes",
	'7713' => "Libéralités perçues",
	'7714' => "Rentrées sur créances amorties",
	'7715' => "Subventions d’équilibre",
	'7717' => "Dégrèvements d’impôts (autres qu’impôts sur les bénéfices)",
	'7718' => "Autres produits exceptionnels sur opérations de gestion",
	'772' => "Produits sur exercices antérieurs (à reclasser)", // Comptes à la disposition des organismes pour enregistrer en cours d’exercice, les produits sur exercices antérieurs.
	'775' => "Produits des cessions d’éléments d’actif",
	'7751' => "Immobilisations incorporelles",
	'7752' => "Immobilisations corporelles",
	'7756' => "Immobilisations financières",
	'7758' => "Autres éléments d’actif", // Sauf stocks et valeurs mobilières de placement.
	'777' => "Quote-part des subventions d’investissement virée au résultat de l’exercice",
	'778' => "Autres produits exceptionnels",
	'7781' => "Bonis provenant de clauses d’indexation",
    '7782' => "Lots",
    '7783' => "Bonis provenant du rachat par l’entreprise d’actions et d’obligations émises par elle-même",
    '7788' => "Produits exceptionnels divers",
	'78' => "Reprises sur amortissements et provisions",
	'781' => "Reprises sur amortissements et provisions", // à inscrire dans les produits d’exploitation
	'7811' => "Reprises sur amortissements des immobilisations incorporelles et corporelles",
	'78111' => "Immobilisations incorporelles",
	'78112' => "Immobilisations corporelles",
	'7815' => "Reprises sur provisions pour risques et charges d’exploitation",
	'7816' => "Reprises sur provisions pour dépréciation des immobilisations incorporelles et corporelles",
	'78161' => "Immobilisations incorporelles",
	'78162' => "Immobilisations corporelles",
	'7817' => "Reprises sur provisions pour  dépréciation des actifs circulants", // Autres que valeurs mobilières de placements.
	'78173' => "Stocks et en-cours",
	'78174' => "Créances",
	'786' => "Reprises sur provisions des produits financiers",
	'7865' => "Reprises sur provisions pour risques et charges financiers",
	'7866' => "Reprises sur provisions pour dépréciation des éléments financiers",
	'78662' => "Immobilisations financières",
	'78665' => "Valeurs mobilières de placement",
	'787' => "Reprises sur provisions des produits exceptionnels",
	'7872' => "Reprises sur provisions réglementées (immobilisations)",
	'78725' => "Amortissements dérogatoires",
	'78726' => "Provision spéciale de réévaluation",
	'78727' => "Plus-values réinvesties",
	'7873' => "Reprises sur provisions réglementées (stocks)",
	'7874' => "Reprises sur autres provisions réglementées",
	'7875' => "Reprises sur provisions exceptionnelles",
	'7876' => "Reprises sur provisions pour dépréciations exceptionnelles",
	'789' => "Report des ressources non utilisées des exercices antérieurs",
	'7893' => "Report des ressources non utilisées des fondations abritées",
	'7894' => "Report des ressources non utilisées sur subventions attribuées",
	'7895' => "Report des ressources non utilisées sur dons manuels affectés",
	'7897' => "Report des ressources non utilisées sur legs et donations affectés",
	'79' => "Transferts de charges", // Autres que les transferts de charges aux comptes d'immobilisations couverts par le compte 72.
	'791' => "Transferts de charges d’exploitation",
	'796' => "Transferts de charges financières",
	'797' => "Transferts de charges exceptionnelles",

	'8' => "Contributions volontaires / Comptes spéciaux", // La classe 8 est utilisée pour satisfaire à des exigences d’information relatives aux documents de synthèse (Bilan : compte 89, Compte de Résultat : compte 88 et Annexe : compte 80).
	'80' => "Engagements", // Les organismes peuvent également regrouper les engagements dans un livre comptable dont la tenue est adaptée à leurs besoins et à leurs moyens.
	'801' => "Engagements donnés par l’entité",
	'8011' => "Avals, cautions, garanties",
	'8014' => "Effets circulant sous l’endos de l’entité",
	'8016' => "Redevances crédit-bail restant à courir",
	'80161' => "Crédit-bail mobilier",
	'80162' => "Crédit-bail immobilier",
	'8018' => "Autres engagements donnés",
	'802' => "Engagements reçus par l’entité",
	'8021' => "Avals, cautions, garanties",
	'8024' => "Créances escomptées non échus",
	'8026' => "Engagements reçus pour utilisation en crédit-bail",
	'80261' => "Crédit-bail mobilier",
	'80262' => "Crédit-bail immobilier",
#	'80265' => "Crédit-bail immobilier",
	'8028' => "Autres engagements reçus",
	'809' => "Contrepartie des engagements",
	'8091' => "Contrepartie des engagements donnés par l’entité", //= "Contrepartie 801".
	'8092' => "Contrepartie des engagements reçus par l’entité", //= "Contrepartie 802".
	'86' => "Emploi des contributions volontaires en nature",
	'860' => "Secours en nature, alimentaires, vestimentaires …",
	'861' => "Mise à disposition gratuite de biens",
	'8611' => "Mise à disposition gratuite de locaux",
	'8612' => "Mise à disposition gratuite de matériels",
	'862' => "Prestations",
	'864' => "Personnel bénévole",
	'87' => "Contributions volontaires en nature",
	'870' => "Bénévolat",
	'871' => "Prestations en nature",
	'875' => "Dons en nature",
	'88' => "Résultat en instance d’affectation", // Ce compte peut être utilisé par l’entité pour l’affectation du résultat de l’exercice précédent.
	'89' => "Bilan",
	'890' => "Bilan d’ouverture", // Pour la réouverture des comptes de l’exercice.
	'891' => "Bilan de clôture", // Pour la clôture des comptes de l’exercice.

#	'9' => "Comptes analytiques", // Classe abrogée ! Récupérée pour information dans le fascicule 1998 chez Dunod : code=043648 ISBN=2-10-003648-3 EAN=9-782100-036486
#	'90' => "Competes réfléchis",
#	'903' => "Stock et provisions pour dépréciation des stocks réfléchis",
#	'904' => "Achats réfléchis",
#	'905' => "Charges réfléchies",
#	'906' => "Dotations réfléchies",
#	'907' => "Produits réfléchis",
#	'91' => "Reclassement préalable des charges et des produits de la comptabilité générale", // 910 a 918 : Reclassement préalable des charges de la comptabilité générale ; attribution selon les besoins de l’organisme
#	'919' => "Produits de la comptabilité générale reclassée",
#	'92' => "Centres d’analyse (centres de travail et sections)",
#	'920' => "Centres d’administration",
#	'921' => "Centres de financement",
#	'922' => "Centres de gestion du personnel",
#	'923' => "Centres de gestion des moyens matériels",
#	'924' => "Centres de prestations connexes",
#	'925' => "Centres d’approvisionnement",
#	'926' => "Centres d’étude technique et recherche",
#	'927' => "Centres de production",
#	'928' => "Centres de distribution",
#	'929' => "Autres frais à couvrir",
#	'93' => "Coûts des produits stockes ", // Attribution selon les besoins de l’organisme
#	'94' => "Stocks",
#	'940' => "Marchandises",
#	'941' => "Matières premières et fournitures",
#	'942' => "Autres approvisionnements (matières et fournitures consommables, emballages commerciaux, …)",
#	'943' => "Production de biens en cours",
#	'944' => "Production de services en cours",
#	'945' => "Produits (intermédiaires, finis, …)",
#	'949' => "Provisions pour dépréciation des stocks et en-cours",
#	'95' => "Coûts des produits vendus", // Attribution selon les besoins de l’organisme
#	'96' => "Écarts sur coûts préétablis", // Utilisation selon les besoins de l’organisme
#	'97' => "Différences de traitement comptable",
#	'970' => "Différences d’incorporation sur matières", // Ces différences, saisies comme ici, dans le groupe de comptes 97, pourraient être aussi bien intégrées dans une méthode plus développée de comptabilisation à coûts préétablis qui conduirait à analyser ces écarts dans le groupe de comptes 96.
#	'971' => "Différences d’incorporation pour amortissements et provisions",
#	'972' => "Différences d’incorporation pour éléments supplétifs",
#	'973' => "Différences d’incorporation sur autres charges de la comptabilité générale",
#	'974' => "Différences d’inventaire constatées",
#	'975' => "Différences sur coûts et taux de cession", //
#	'976' => "Differences sur niveau d’activité", //
#	'977' => "Différence d’incorporation sur produits de la comptabilité générale",
#	'978' => "", // Usage selon besoin de l’organisme
#	'979' => "", // Usage selon besoin de l’organisme
#	'98' => "Résultats de comptabilité analytique", // Attribution selon les besoins de l’organisme
#	'99' => "Liaisons internes",
#	'991' => "Liaisons internes propres à un même établissement",
#	'996' => "Cessions reçues d’autres établissements",
#	'997' => "Cessions fournies à d’autres établissements",

);

?>