<?php
/***************************************************************************\
 *  ComptaSPIP, extension comptable
 *
 * @read (licence, copyrigth, authors, credits)
 *  ../plugin.xml
\***************************************************************************/

if (!defined('_ECRIRE_INC_VERSION'))
	return;

// http://www.izf.net/pages/uemoa-syscoa/2365/
// http://www.cpcc-rdc.org/Classification_Ohada.html
// N° 99-01 du 16 février 1999 relatif aux modalités d’établissement des comptes
// http://www.ohada.com/actes-uniformes/693/860/tableau-cadre-comptable-du-systeme-comptable-ohada.html
// http://fr.wikipedia.org/wiki/Plan_comptable_%28OHADA%29
// http://www.droit-afrique.com/images/textes/Ohada/Ohada%20-%20Acte%20uniforme%202000%20(Plan%20des%20comptes).pdf
// http://www.adoc-sn.com/doc/Livre-Vert%20du%20SYSCOA.pdf
// http://www.rag.sn/IMG/pdf/doc-35.pdf
// http://hal-auf.archives-ouvertes.fr/docs/00/58/46/10/PDF/BIGOU-LARE.pdf
// http://www.ohada.org/documentation.html
//
$GLOBALS[$GLOBALS['idx_lang']] = array(

	'1' => "Comptes de ressources durables",
	'10' => "Capital",
	'101' => "Capital social",
	'1011' => "Capital souscrit, non appelé",
	'1012' => "Capital souscrit, appelé, non versé",
	'1013' => "Capital souscrit, appelé, versé, non amorti",
	'1014' => "Capital souscrit, appelé, versé, amorti",
	'1018' => "Capital souscrit soumis à des conditions particulières",
	'102' => "Capital par dotation",
	'1021' => "Dotation initiale",
	'1022' => "Dotations complémentaires",
	'1028' => "Autres dotations",
	'103' => "Capital personnel",
	'104' => "Compte de l'exploitant",
	'1041' => "Apports temporaires",
	'1042' => "Opérations courantes",
	'1043' => "Rémunérations, impôts et autres charges personnelles",
	'1047' => "Prélèvements d’autoconsommation",
	'1048' => "Autres prélèvements",
	'105' => "Primes liées aux capitaux propres",
	'1051' => "Primes d'émission",
	'1052' => "Primes d'apport",
	'1053' => "Primes de fusion",
	'1054' => "Primes de conversion",
	'1058' => "Autres primes",
	'106' => "Écarts de réevaluation",
	'1061' => "Écarts de réévaluation légale",
	'1062' => "Écarts de réévaluation libre",
	'109' => "Actionnaires, capital souscrit, non appelé",
	'11' => "Réserves",
	'111' => "Réserve légale",
	'112' => "Réserves statutaires ou contractuelles",
	'113' => "Réserves réglementées",
	'1131' => "Réserves de plus-values nettes à long terme",
	'1133' => "Réserves consécutives à l'octroi de subventions d'investissement",
	'1138' => "Autres réserves réglementées",
	'118' => "Autres réserves",
	'1181' => "Réserves facultatives",
	'1188' => "Réserves divers",
	'12' => "Report à nouveau",
	'121' => "Report à nouveau créditeur",
	'129' => "Report à nouveau débiteur",
	'1291' => "Perte nette à reporter",
	'1292' => "Perte - Amortissements réputés différés",
	'13' => "Résultat net de l'exercice",
	'130' => "Résultat en instance d'affectation",
	'1301' => "Résultat en instance d'affectation: bénéfice",
	'1309' => "Résultat en instance d'affectation: perte",
	'131' => "Résultat net: bénéfice",
	'132' => "Marge brute (M.B.)",
	'133' => "Valeur ajoutée (V.A.)",
	'134' => "Excédent brut d'exploitation (E.B.E.)",
	'135' => "Résultat d'exploitation (R.E.)",
	'136' => "Résultat financier (R.F.)",
	'137' => "Résultat des activités ordinaires (R.A.O.)",
	'138' => "Résultat hors activités ordinaires (R.H.A.O.)",
	'139' => "Résultat net: perte",
	'14' => "Subventions d'investissement",
	'141' => "Subventions d'équipement A",
	'1411' => "État",
	'1412' => "Régions",
	'1413' => "Départements",
	'1414' => "Communes et collectivités publiques décentralisées",
	'1415' => "Entreprises publiques ou mixtes",
	'1416' => "Entreprises et organismes privés",
	'1417' => "Organismes internationaux",
	'1418' => "Autres",
	'142' => "Subventions d'équipement B",
	'15' => "Provisions réglementées et fonds assimilés",
	'151' => "Amortissements dérogatoires",
	'152' => "Plus-values de cession à réinvestir",
	'153' => "Fonds réglementés",
	'1531' => "Fonds National",
	'1532' => "Prélèvement pour le Budget",
	'154' => "Provision spéciale de réévaluation",
	'155' => "Provisions réglementées relatives aux immobilisations",
	'1551' => "Reconstitution des gisements miniers et pétroliers",
	'156' => "Provisions réglementées relatives aux stocks",
	'1561' => "Hausse de prix",
	'1562' => "Fluctuation des cours",
	'157' => "Provisions pour investissement",
	'158' => "Autres provisions et fonds réglementes",
	'16' => "Emprunts et dettes assimilées",
	'161' => "Emprunts obligataires",
	'1611' => "Emprunts obligataires ordinaires",
	'1612' => "Emprunts obligataires convertibles",
	'1618' => "Autres emprunts obligataires",
	'162' => "Emprunts et dettes auprès des établissements de crédit",
	'163' => "Avances reçues de l'État",
	'164' => "Avances reçues et comptes courants bloqués",
	'165' => "Dépôts et cautionnements reçus",
	'1651' => "Dépôts",
	'1652' => "Cautionnements",
	'166' => "Intérêts courus",
	'1661' => "sur emprunts obligataires",
	'1662' => "sur emprunts et dettes auprès des établissements de crédit",
	'1663' => "sur avances reçues de l'État",
	'1664' => "sur avances reçues et comptes courants bloqué",
	'1665' => "sur dépôts et cautionnements reçus",
	'1667' => "sur avances assorties de conditions particulières",
	'1668' => "sur autres emprunts et dettes",
	'167' => "Avances assorties de conditions particulières",
	'1671' => "Avances bloquées pour augmentation du capital",
	'1672' => "Avances conditionnées par l'État",
	'1673' => "Avances conditionnées par les autres organismes africains",
	'1674' => "Avances conditionnées par les organismes internationaux",
	'1676' => "Droits du concédant exigibles en nature",
	'168' => "Autres emprunts et dettes",
	'1681' => "Rentes viagères capitalisées",
	'1682' => "Billets de fonds",
	'1683' => "Dettes consécutives à des titres empruntés",
	'1684' => "Dettes du concédant exigibles en nature",
	'1685' => "Emprunts participatifs",
	'1686' => "Participation des travailleurs aux bénéfices",

	'17' => "Dettes de crédit-bail et contrats assimilés",
	'172' => "Emprunts équivalents de crédit - bail immobilier",
	'173' => "Emprunts équivalents de crédit - bail mobilier",
	'176' => "Intérêts courus",
	'1762' => "sur emprunts équivalents de crédit – bail immobilier",
	'1763' => "sur emprunts équivalents de crédit – bail mobilier",
	'1768' => "sur emprunts équivalents d’autres contrats",
	'178' => "Emprunts équivalents d’autres contrats",
	'18' => "Dettes liées à des participations et comptes de liaison des établissements et sociétés en participation",
	'181' => "Dettes liées à des participations",
	'1811' => "Dettes liées à des participations (groupe)",
	'1812' => "Dettes liées à des participations (hors groupe)",
	'182' => "Dettes liées à des sociétés en participation",
	'183' => "Intérêts courus sur dettes liées à des participations",
	'184' => "Comptes permanents bloqués des établissements et succursales",
	'185' => "Comptes permanents non bloqués des établissements et succursales",
	'186' => "Comptes de liaison charges",
	'187' => "Comptes de liaison produits",
	'188' => "Comptes de liaison des sociétés en participation",
	'19' => "Provisions financières pour risques et charges",
	'191' => "Provisions pour litiges",
	'192' => "Provisions pour garanties données aux clients",
	'193' => "Provisions pour pertes sur marchés à achèvement futur",
	'194' => "Provisions pour pertes de change",
	'195' => "Provisions pour impôts",
	'196' => "Provisions pour pensions et obligations similaires",
	'197' => "Provisions pour charges à repartir sur plusieurs exercices",
	'1971' => "Provisions pour grosses réparations",
	'198' => "Autres provisions financières pour risques et charges",
	'1981' => "Provisions pour amendes et pénalités",
	'1982' => "Provisions pour renouvellement des immobilisations (entreprises
	'concessionnaires)",
	'1983' => "Provisions de propre assureur",
	'1988' => "Autres provisions financières pour risques et charges",

	'2' => "Comptes de l’actif immobilisé",
	'20' => "Charges immobilisées",
	'201' => "Frais d'établissement",
	'2011' => "Frais de constitution",
	'2012' => "Frais de prospection",
	'2013' => "Frais de publicité et de lancement",
	'2014' => "Frais de fonctionnement antérieurs au démarrage",
	'2015' => "Frais de modification du capital (fusions, scissions, transformations)",
	'2016' => "Frais d'entrée à la Bourse",
	'2017' => "Frais de restructuration",
	'2018' => "Frais divers d'établissement",
	'202' => "Charges à répartir sur plusieurs exercices",
	'2021' => "Charges différées",
	'2022' => "Frais d'acquisition d'immobilisations",
	'2026' => "Frais d'émission des emprunts",
	'2028' => "Charges à étaler",
	'206' => "Primes de remboursement des obligations",
	'2061' => "Obligations ordinaires",
	'2062' => "Obligations convertibles",
	'2068' => "Autres emprunts obligataires",
	'21' => "Immobilisations incorporelles",
	'211' => "Frais de recherche et de développement",
	'212' => "Brevets, licences, concessions et droits similaires",
	'213' => "Logiciels",
	'214' => "Marques",
	'215' => "Fonds commercial",
	'216' => "Droit au bail",
	'217' => "Investissements de création",
	'218' => "Autres droits et valeurs incorporels",
	'219' => "Immobilisations incorporelles en cours",
	'2191' => "Frais de recherche et de développement",
	'2193' => "Logiciels",
	'2198' => "Autres droits et valeurs incorporels",
	'22' => "Terrains",
	'221' => "Terrains agricoles et forestiers",
	'2211' => "Terrains d'exploitation agricole",
	'2212' => "Terrains d'exploitation forestière",
	'2218' => "Autres terrains",
	'222' => "Terrains nus",
	'2221' => "Terrains à bâtir",
	'2228' => "Autres terrains nus",
	'223' => "Terrains bâtis",
	'2231' => "pour bâtiments industriels et agricoles",
	'2232' => "pour bâtiments administratifs et commerciaux",
	'2234' => "pour bâtiments affectés aux autres opérations professionnelles",
	'2235' => "pour bâtiments affectés aux autres opérations non professionnelles",
	'2238' => "Autres terrains bâtis",
	'224' => "Travaux de mise en valeur des terrains",
	'2241' => "Plantation d'arbres et d'arbustes",
	'2248' => "Autres travaux",
	'225' => "Terrains de gisement",
	'2251' => "Carrières",
	'226' => "Terrains aménagés",
	'2261' => "Parkings",
	'227' => "Terrains mis en concession",
	'228' => "Autres terrains",
	'2281' => "Terrains des immeubles de rapport",
	'2285' => "Terrains des logements affectés au personnel",
	'2288' => "Autres terrains",
	'229' => "Aménagements de terrains en cours",
	'2291' => "Terrains agricoles et forestiers",
	'2292' => "Terrains nus",
	'2295' => "Terrains de gisement",
	'2298' => "Autres terrains",
	'23' => "Bâtiments, installations techniques et agencements",
	'231' => "Bâtiments industriels, agricoles, administratifs et commerciaux sur sol propre",
	'2311' => "Bâtiments industriels",
	'2312' => "Bâtiments agricoles",
	'2313' => "Bâtiments administratifs et commerciaux",
	'2314' => "Bâtiments affectés au logement du personnel",
	'2315' => "Immeubles de rapport",
	'232' => "Bâtiments industriels, agricoles, administratifs et commerciaux sur sol d’autrui",
	'2321' => "Bâtiments industriels",
	'2322' => "Bâtiments agricoles",
	'2323' => "Bâtiments administratifs et commerciaux",
	'2324' => "Bâtiments affectés au logement du personnel",
	'2325' => "Immeubles de rapport",
	'233' => "Ouvrages d’infrastructure",
	'2331' => "Voies de terre",
	'2332' => "Voies de fer",
	'2333' => "Voies d’eau",
	'2334' => "Barrages, Digues",
	'2335' => "Pistes d’aérodrome",
	'2338' => "Autres",
	'234' => "Installations techniques",
	'2341' => "Installations complexes spécialisées sur sol propre",
	'2342' => "Installations complexes spécialisées sur sol d’autrui",
	'2343' => "Installations à caractère spécifique sur sol propre",
	'2344' => "Installations à caractère spécifique sur sol d’autrui",
	'235' => "Aménagements de bureaux",
	'2351' => "Installations générales",
	'2358' => "Autres",
	'237' => "Bâtiments industriels, agricoles et commerciaux mis en concession",
	'238' => "Autres installations et agencements",
	'239' => "Bâtiments et installations en cours",
	'24' => "Matériel",
	'241' => "Matériel et outillage industriel et commercial",
	'2411' => "Matériel industriel",
	'2412' => "Outillage industriel",
	'2413' => "Matériel commercial",
	'2414' => "Outillage commercial",
	'242' => "Matériel et outillage agricole",
	'2421' => "Matériel agricole",
	'2422' => "Outillage agricole",
	'243' => "Matériel d’emballage récupérable et identifiable",
	'244' => "Matériel et mobilier",
	'2441' => "Matériel de bureau",
	'2442' => "Matériel informatique",
	'2443' => "Matériel bureautique",
	'2444' => "Mobilier de bureau",
	'2446' => "Matériel et mobilier des immeubles de rapport",
	'2447' => "Matériel et mobilier des logements du personnel",
	'245' => "Matériel de transport",
	'2451' => "Matériel automobile",
	'2452' => "Matériel ferroviaire",
	'2453' => "Matériel fluvial, lagunaire",
	'2454' => "Matériel naval",
	'2455' => "Matériel aérien",
	'2456' => "Matériel hippomobile",
	'2458' => "Autres (vélo, mobylette, moto)",
	'246' => "Immobilisations animales et agricoles",
	'2461' => "Cheptel, animaux de trait",
	'2462' => "Cheptel, animaux reproducteurs",
	'2463' => "Animaux de garde",
	'2465' => "Plantations agricoles",
	'2468' => "Autres",
	'247' => "Agencements et aménagements du matériel",
	'248' => "Autres matériels",
	'2481' => "Collections et œuvres d’art",
	'249' => "Matériel en cours",
	'2491' => "Matériel et outillage industriel et commercial",
	'2492' => "Matériel et outillage agricole",
	'2493' => "Matériel d’emballage récupérable et identifiable",
	'2494' => "Matériel et mobilier de bureau",
	'2495' => "Matériel de transport",
	'2496' => "Immobilisations animales et agricoles",
	'2497' => "Agencements et aménagements du matériel",
	'2498' => "Autres matériels",
	'25' => "Avances et acomptes versés sur immobilisations",
	'251' => "Avances et acomptes versés sur immobilisations incorporelles",
	'252' => "Avances et acomptes versés sur immobilisations corporelles",
	'26' => "Titres de participation",
	'261' => "Titres de participation dans des sociétés sous contrôle exclusif",
	'262' => "Titres de participation dans des sociétés sous contrôle conjoint",
	'263' => "Titres de participation dans des sociétés conférant une influence notable",
	'265' => "Participations dans des organismes professionnels",
	'266' => "Parts dans des groupements d’intérêt économique (G.I.E.)",
	'268' => "Autres titres de participation",
	'27' => "Autres immobilisations financières",
	'271' => "Prêts et créances non commerciales",
	'2711' => "Prêts participatifs",
	'2712' => "Prêts aux associés",
	'2713' => "Billets de fonds",
	'2714' => "Titres prêtés",
	'272' => "Prêts au personnel",
	'2721' => "Prêts immobiliers",
	'2722' => "Prêts mobiliers et d’installation",
	'2728' => "Autres prêts (frais d’études...)",
	'273' => "CRÉANCES SUR L’ÉTAT",
	'2731' => "Retenues de garantie",
	'2733' => "Fonds réglementé",
	'2738' => "Autres",
	'274' => "Titres immobilisés",
	'2741' => "Titres immobilisés de l’activité de portefeuille (T.I.A.P.)",
	'2742' => "Titres participatifs",
	'2743' => "Certificats d’investissement",
	'2744' => "Parts de fonds commun de placement (F.C.P.)",
	'2748' => "Autres titres immobilisés",
	'275' => "Dépôts et cautionnements versés",
	'2751' => "Dépôts pour loyers d’avance",
	'2752' => "Dépôts pour l’électricité",
	'2753' => "Dépôts pour l’eau",
	'2754' => "Dépôts pour le gaz",
	'2755' => "Dépôts pour le téléphone, le télex, la télécopie",
	'2756' => "Cautionnements sur marchés publics",
	'2757' => "Cautionnements sur autres opérations",
	'2758' => "Autres dépôts et cautionnements",
	'276' => "Intérêts courus",
	'2761' => "Prêts et créances non commerciales",
	'2762' => "Prêts au personnel",
	'2763' => "Créances sur l'État",
	'2764' => "Titres immobilisés",
	'2765' => "Dépôts et cautionnements versés",
	'2767' => "Créances rattachées à des participations",
	'2768' => "Immobilisations financières diverses",
	'277' => "Créances rattachées à des participations et avances à des G.I.E.",
	'2771' => "Créances rattachées à des participations (groupe)",
	'2772' => "Créances rattachées à des participations (hors groupe)",
	'2773' => "Créances rattachées à des sociétés en participation",
	'2774' => "Avances à des Groupements d'intérêt économique (G.I.E.)",
	'278' => "Immobilisations financières diverses",
	'2781' => "Créances diverses groupe",
	'2782' => "Créances divers hors groupe",
	'2785' => "Or et métaux précieux", // Pièces, barres, lingots, louis d'or et autres métaux précieux (argent, diamant...) acquis et que l'entreprise a l'intention de conserver de manière durable.
	'28' => "Amortissements des immobilisations",
	'281' => "Amortissements des immobilisations incorporelles",
	'2811' => "Amortissements des frais de recherche et de développement",
	'2812' => "Amortissements des brevets, licences, concessions et droits similaires",
	'2813' => "Amortissements des logiciels",
	'2814' => "Amortissements des marques",
	'2815' => "Amortissements du fonds commercial",
	'2816' => "Amortissements du droit au bail",
	'2817' => "Amortissements des investissements de création",
	'2818' => "Amortissements des autres droits et valeurs incorporels",
	'282' => "Amortissements des terrains",
	'2821' => "Amortissements des terrains agricoles et forestiers",
	'2824' => "Amortissements des travaux de mise en valeur des terrains",
	'2825' => "Amortissements des terrains de gisement",
	'283' => "Amortissements des bâtiments, installations techniques et agencements",
	'2831' => "Amortissements des bâtiments industriels, agricoles, administratifs et commerciaux sur sol propre",
	'2832' => "Amortissements des bâtiments industriels, agricoles, administratifs et commerciaux sur sol d'autrui",
	'2833' => "Amortissements des ouvrages d'infrastructure",
	'2834' => "Amortissements des installations techniques",
	'2835' => "Amortissements des aménagements de bureaux",
	'2837' => "Amortissements des bâtiments industriels, agricoles et commerciaux mis en concession",
	'2838' => "Amortissements des autres installations et agencements",
	'284' => "AMortissements du matériel",
	'2841' => "Amortissements du matériel et outillage industriel et commercial",
	'2842' => "Amortissements du matériel et outillage agricole",
	'2843' => "Amortissements du matériel d'emballage récupérable et identifiable",
	'2844' => "Amortissements du matériel et mobilier",
	'2845' => "Amortissements du matériel de transport",
	'2846' => "Amortissements des immobilisations animales et agricoles",
	'2847' => "Amortissements des agencements et aménagements du matériel",
	'2848' => "Amortissements des autres matériel",
	'29' => "Provisions pour dépréciation des immobilisations",
	'291' => "Provisions pour dépréciation des immobilisations incorporelles",
	'2912' => "Provisions pour dépréciation des brevets, licences, concessions et	droits similaires",
	'2913' => "Provisions pour dépréciation des logiciels",
	'2914' => "Provisions pour dépréciation des marques",
	'2915' => "Provisions pour dépréciation du fonds commercial",
	'2916' => "Provisions pour dépréciation du droit au bail",
	'2917' => "Provisions pour dépréciation des investissements de création",
	'2918' => "Provisions pour dépréciation des autres droits et valeurs incorporels",
	'2919' => "Provisions pour dépréciation des immobilisations incorporelles en cours",
	'292' => "Provisions pour dépréciation des terrains",
	'2921' => "Provisions pour dépréciation des terrains agricoles et forestiers",
	'2922' => "Provisions pour dépréciation des terrains nus",
	'2923' => "Provisions pour dépréciation des terrains bâtis",
	'2924' => "Provisions pour dépréciation des travaux de mise en valeur des terrains",
	'2925' => "Provisions pour dépréciation des terrains de gisement",
	'2926' => "Provisions pour dépréciation des terrains aménagés",
	'2927' => "Provisions pour dépréciation des terrains mis en concession",
	'2928' => "Provisions pour dépréciation des autres terrains",
	'2929' => "Provisions pour dépréciation des aménagements de terrains en cours",
	'293' => "Provisions pour dépréciation des bâtiments, installations techniques et agencements",
	'2931' => "Provisions pour dépréciation des bâtiments industriels, agricoles, administratifs et commerciaux sur sol propre",
	'2932' => "Provisions pour dépréciation des bâtiments industriels, agricoles, administratifs et commerciaux sur sol d'autrui",
	'2933' => "Provisions pour dépréciation des ouvrages d'infrastructures",
	'2934' => "Provisions pour dépréciation des installations techniques",
	'2935' => "Provisions pour dépréciation des aménagements de bureaux",
	'2937' => "Provisions pour dépréciation des bâtiments industriels, agricoles et commerciaux mis en concession",
	'2938' => "Provisions pour dépréciation des autres installations et agencements",
	'2939' => "Provisions pour dépréciation des bâtiments et installations en cours",
	'294' => "Provisions pour dépréciation de matériel",
	'2941' => "Provisions pour dépréciation du matériel et outillage industriel et commercial",
	'2942' => "Provisions pour dépréciation du matériel et outillage agricole",
	'2943' => "Provisions pour dépréciation du matériel d'emballage récupérable et identifiable",
	'2944' => "Provisions pour dépréciation du matériel et mobilier",
	'2945' => "Provisions pour dépréciation du matériel de transport",
	'2946' => "Provisions pour dépréciation des immobilisations animales et agricoles",
	'2947' => "Provisions pour dépréciation des agencements et aménagements du matériel",
	'2948' => "Provisions pour dépréciation des autres matériels",
	'2949' => "Provisions pour dépréciation de matériel en cours",
	'295' => "Provisions pour dépréciation des avances et acomptes versés sur immobilisations",
	'2951' => "Provisions pour dépréciation des avances et acomptes versés sur immobilisations incorporelles",
	'2952' => "Provisions pour dépréciation des avances et acomptes versés sur immobilisations corporelles",
	'296' => "Provisions pour dépréciation des titres de participation",
	'2961' => "Provisions pour dépréciation des titres de participation dans des sociétés sous contrôle exclusif",
	'2962' => "Provisions pour dépréciation des titres de participation dans les sociétés sous contrôle conjoint",
	'2963' => "Provisions pour dépréciation des titres de participation dans les sociétés conférant une influence notable",
	'2965' => "Provisions pour dépréciation des participations dans des organismes professionnels",
	'2966' => "Provisions pour dépréciation des parts dans des G.I.E.",
	'2968' => "Provisions pour dépréciation des autres titres de participation",
	'297' => "Provisions pour dépréciation des autres immobilisations financières",
	'2971' => "Provisions pour dépréciation des prêts et créances non commerciales",
	'2972' => "Provisions pour dépréciation des prêts au personnel",
	'2973' => "Provisions pour dépréciation des créances sur l'État",
	'2974' => "Provisions pour dépréciation des titres immobilisés",
	'2975' => "Provisions pour dépréciation des dépôts et cautionnements versés",
	'2977' => "Provisions pour dépréciation des créances rattachées à des participations et avances à des GIE",
	'2978' => "Provisions pour dépréciation des créances financières diverses",

	'3' => "Comptes de stocks",
	'31' => "Marchandises",
	'311' => "Marchandises A",
	'3111' => "Marchandises A1",
	'3112' => "Marchandises A2",
	'312' => "Marchandises B",
	'3121' => "Marchandises B1",
	'3122' => "Marchandises B2",
	'318' => "Marchandises hors activités ordinaires (H.A.O.)",
	'32' => "Matières premières et fournitures liées",
	'321' => "Matières A",
	'322' => "Matières B",
	'323' => "Fournitures (A,B)",
	'33' => "Autres approvisionnements",
	'331' => "Matières consommables",
	'332' => "Fournitures d'atelier et d'usine",
	'333' => "Fournitures de magasin",
	'334' => "Fournitures de bureau",
	'335' => "Emballages",
	'3351' => "Emballages perdus",
	'3352' => "Emballages récupérables non identifiables",
	'3353' => "Emballages à usage mixte",
	'3358' => "Autres emballages",
	'338' => "Autres matières",
	'34' => "Produits en cours",
	'341' => "Produits en cours",
	'3411' => "Produits en cours P1",
	'3412' => "Produits en cours P2",
	'342' => "Travaux en cours",
	'3421' => "Travaux en cours T1",
	'3422' => "Travaux en cours T2",
	'343' => "Produits intermédiaires en cours",
	'3431' => "Produits intermédiaires A",
	'3432' => "Produits intermédiaires B",
	'344' => "Produits résiduels en cours",
	'3441' => "Produits résiduels A",
	'3442' => "Produits résiduels B",
	'35' => "Services en cours",
	'351' => "Études en cours",
	'3511' => "Études en cours E1",
	'3512' => "Études en cours E2",
	'352' => "Prestations de services en cours",
	'3521' => "Prestations de services S1",
	'3522' => "Prestations de services S2",
	'36' => "Produits finis",
	'361' => "Produits finis A",
	'362' => "Produits finis B",
	'37' => "Produits intermédiaires et résiduels",
	'371' => "Produits intermédiaires",
	'3711' => "Produits intermédiaires A",
	'3712' => "Produits intermédiaires B",
	'372' => "Produits résiduels",
	'3721' => "Déchets",
	'3722' => "Rebuts",
	'3723' => "Matières de Récupération",
	'38' => "Stocks en cours de route, en consignation ou en dépôt",
	'381' => "Marchandises en cours de route",
	'382' => "Matières premières et fournitures liées en cours de route",
	'383' => "Autres approvisionnements en cours de route",
	'386' => "Produits finis en cours de route",
	'387' => "Stock en consignation ou en dépôt",
	'3871' => "Stock en consignation",
	'3872' => "Stock en dépôt",
	'388' => "Stock provenant d'immobilisations mises hors service ou au rebut",
	'39' => "Dépréciation des stocks",
	'391' => "Dépréciations des stocks de marchandises",
	'392' => "Dépréciations des stocks de matières premières et fournitures liées",
	'393' => "Dépréciations des stocks d'autres appovisionnements",
	'394' => "Dépréciations des productions en cours",
	'395' => "Dépréciations des services en cours",
	'396' => "Dépréciations des stocks de produits finis",
	'397' => "Dépréciations des stocks de produits intermédiaires et résiduels",
	'398' => "Dépréciations des stocks en cours de route, en consignation ou en dépôt",

	'4' => "Comptes de tiers",
	'40' => "Fournisseurs et comptes rattachés",
	'401' => "Fournisseurs, dettes en compte",
	'4011' => "Fournisseurs",
	'4012' => "Fournisseurs Groupe",
	'4013' => "Fournisseurs sous-traitants",
	'4017' => "Fournisseur, retenues de garantie",
	'402' => "Fournisseurs, effets à payer",
	'4021' => "Fournisseurs, Effets à payer",
	'4022' => "Fournisseurs - Groupe, Effets à payer",
	'4023' => "Fournisseurs sous-traitants, Effets à payer",
	'408' => "Fournisseurs, factures non parvenues",
	'4081' => "Fournisseurs",
	'4082' => "Fournisseurs - Groupe",
	'4083' => "Fournisseurs sous-traitants",
	'4086' => "Fournisseurs, intérêts courus",
	'409' => "Fournisseurs débiteurs",
	'4091' => "Fournisseurs avances et acomptes versés",
	'4092' => "Fournisseurs - Groupe avances et acomptes versés",
	'4093' => "Fournisseurs sous-traitants avances et acomptes versés",
	'4094' => "Fournisseurs créances pour emballages et matériels à rendre",
	'4098' => "Rabais, Remises, Ristournes et autres avoirs à obtenir",
	'41' => "Clients et comptes rattachés",
	'411' => "Clients",
	'4111' => "Clients",
	'4112' => "Clients - Groupe",
	'4114' => "Clients, État et Collectivités publiques",
	'4115' => "Clients, organismes internationaux",
	'4117' => "Client, retenues de garantie",
	'4118' => "Clients, dégrèvement de Taxes sur la Valeur Ajoutée (T.V.A.)",
	'412' => "Clients, éffets à recevoir en portefeuille",
	'4121' => "Clients, Effets à recevoir",
	'4122' => "Clients - Groupe, Effets à recevoir",
	'4124' => "État et Collectivités publiques, Effets à recevoir",
	'4125' => "Organismes Internationaux, Effets à recevoir",
	'414' => "CRÉANCES SUR CESSIONS D'IMMOBILISATIONS",
	'4141' => "Créances en compte",
	'4142' => "Effets à recevoir",
	'415' => "Clients, éffets escomptés non échus",
	'416' => "Créances clients litigieuses ou douteuses",
	'4161' => "Créances litigieuses",
	'4162' => "Créances douteuses",
	'418' => "Clients, produits à recevoir",
	'4181' => "Clients, factures à établir",
	'4186' => "Clients, intérêts courus",
	'419' => "Clients créditeurs",
	'4191' => "Clients, avances et acomptes reçus",
	'4192' => "Clients - Groupe, avances et acomptes reçus",
	'4194' => "Clients, dettes pour emballages et matériels consignés",
	'4198' => "Rabais, Remises, Ristournes et autres avoirs à accorde",
	'42' => "Personnel et comptes rattachés",
	'421' => "Personnel, avances et acomptes",
	'4211' => "Personnel, avances",
	'4212' => "Personnel, acomptes",
	'4213' => "Frais avancés et fournitures au personnel",
	'422' => "Personnel, rémunérations dues",
	'423' => "Personnel, oppositions, saisies-arrêts",
	'4231' => "Personnel, oppositions",
	'4232' => "Personnel, saisies-arrêts",
	'4233' => "Personnel, avis à tiers détenteur",
	'424' => "Personnel, oeuvres sociales internes",
	'4241' => "Assistance médicale",
	'4242' => "Allocations familiales",
	'4245' => "Organismes sociaux rattachés à l'entreprise",
	'4248' => "Autres oeuvres sociales internes",
	'425' => "Représentants du personnel",
	'4251' => "Délégués du personnel",
	'4252' => "Syndicats et Comités d'entreprises, d'Établissement",
	'4258' => "Autres représentants du personnel",
	'426' => "Personnel, participation aux bénéfices",
	'427' => "Personnel – dépôts",
	'428' => "Personnel, charges à payer et produits à recevoir",
	'4281' => "Dettes provisionnées pour congés à payer",
	'4286' => "Autres Charges à payer",
	'4287' => "Produits à recevoir",
	'43' => "Organismes sociaux",
	'431' => "Sécurité sociale",
	'4311' => "Prestations familiales",
	'4312' => "Accidents de travail",
	'4313' => "Caisse de retraite obligatoire",
	'4314' => "Caisse de retraite facultative",
	'4318' => "Autres cotisations sociales",
	'432' => "Caisses de retraite complémentaire",
	'433' => "Autres organismes sociaux",
	'4331' => "Mutuelle",
	'438' => "Organismes sociaux, charges à payer et produits à recevoir",
	'4381' => "Charges sociales sur gratifications à payer",
	'4382' => "Charges sociales sur congés à payer",
	'4386' => "Autres charges à payer",
	'4387' => "Produits à recevo",
	'44' => "État et collectivités publiques",
	'441' => "État, impôt sur les bénéfices",
	'442' => "État, autres impôts et taxes",
	'4421' => "Impôts et taxes d'Etat",
	'4422' => "Impôts et taxes pour les collectivités publiques",
	'4423' => "Impôts et taxes recouvrables sur des obligataires",
	'4424' => "Impôts et taxes recouvrables sur des associés",
	'4426' => "Droits de douane",
	'4428' => "Autres impôts et taxes",
	'443' => "État, T.V.A. FACTURÉE",
	'4431' => "T.V.A. facturée sur ventes",
	'4432' => "T.V.A. facturée sur prestations de services",
	'4433' => "T.V.A. facturée sur travaux",
	'4334' => "T.V.A. facturée sur production livrée à soi-même",
	'4335' => "T.V.A. sur factures à établir",
	'444' => "État, T.V.A. due ou crédit de T.V.A.",
	'4441' => "État, T.V.A. due",
	'4449' => "État, crédit de T.V.A. à reporter",
	'445' => "État, T.V.A. récupérable",
	'4451' => "T.V.A. récupérable sur immobilisations",
	'4452' => "T.V.A. récupérable sur achats",
	'4453' => "T.V.A. récupérable sur transport",
	'4454' => "T.V.A. récupérable sur services extérieurs et autres charges",
	'4455' => "T.V.A. récupérable sur factures non parvenues",
	'4456' => "T.V.A. transférée par d'autres entreprises",
	'446' => "État, autres taxes sur le chiffre d'affaires",
	'447' => "État, impôts retenus à la source",
	'4471' => "Impôt Général sur le revenu",
	'4472' => "Impôts sur salaires",
	'4473' => "Contribution nationale",
	'4474' => "Contribution nationale de solidarité",
	'4478' => "Autres impôts et contributions",
	'448' => "État, charges à payer et produits à recevoir",
	'4486' => "Charges à payer",
	'4487' => "Produits à recevoir",
	'449' => "État, créances et dettes diverses",
	'4491' => "État, obligations cautionnées",
	'4492' => "État, avances et acomptes versés sur impôts",
	'4493' => "État, fonds de dotation à recevoir",
	'4494' => "État, subventions d'équipement à recevoir",
	'4495' => "État, subventions d'exploitation à recevoir",
	'4496' => "État, subventions d'équilibre à recevoir",
	'4499' => "État, fonds réglementé provisionné",
	'45' => "Organismes internationaux",
	'451' => "Opérations avec les organismes africains",
	'452' => "Opérations avec les autres organismes internationaux",
	'458' => "Organismes internationaux, fonds de dotation et subventions à recevoir",
	'4581' => "Organismes internationaux, fonds de dotation à recevoir",
	'4582' => "Organismes internationaux, subventions à recevoir",
	'46' => "Associés et groupe",
	'461' => "Associés, opérations sur le capital",
	'4611' => "Associés apports en nature",
	'4612' => "Associés apports en numéraire",
	'4613' => "Actionnaires, capital souscrit appelé non versé",
	'4614' => "Associés, capital appelé non versé",
	'4615' => "Associés, versements reçus sur augmentation de capital",
	'4616' => "Associés, versements anticipés",
	'4617' => "Actionnaires défaillants",
	'4618' => "Associés, autres apports",
	'4619' => "Associés, capital à rembourser",
	'462' => "Associés, comptes courants",
	'4621' => "Principal",
	'4626' => "Intérêts courus",
	'463' => "Associés, opérations faites en commun",
	'465' => "Associés, dividendes à payer",
	'466' => "Groupe, comptes courants",
	'467' => "Actionnaires, restant dû sur capital appelé",
	'47' => "Débiteurs et créditeurs divers",
	'471' => "Comptes d'attente",
	'4711' => "Débiteurs divers",
	'4712' => "Créditeurs divers",
	'472' => "Versements restant à effectuer sur titres non libérés",
	'4726' => "Titres de participation",
	'4727' => "Titres immobilisés",
	'4728' => "Titres de placement",
	'474' => "Répartition périodique des charges et des produits",
	'4746' => "Charges",
	'4747' => "Produits",
	'475' => "Créances sur travaux non encore facturables",
	'476' => "Charges constatées d'avance",
	'477' => "Produits constatés d'avance",
	'478' => "Écarts de conversion - actif",
	'4781' => "Diminution des créances",
	'4782' => "Augmentation des dettes",
	'4788' => "Différences compensées par couverture de change",
	'479' => "Écarts de conversion - passif",
	'4791' => "Augmentation des créances",
	'4792' => "Diminution des dettes",
	'4798' => "Différences compensées par couverture de change",
	'48' => "Créances et dettes hors activités ordinaires (H.A.O.)",
	'481' => "Fournisseurs d'investissements",
	'4811' => "Immobilisations incorporelles",
	'4812' => "Immobilisations corporelles",
	'4817' => "Retenues de garantie",
	'4818' => "Factures non parvenues",
	'482' => "Fournisseurs d'investissements, effets à payer",
	'483' => "Dettes sur acquisition de titres de placement",
	'484' => "Autres dettes hors activites ordinaires (h.a.o.)",
	'485' => "Créances sur cessions d'immobilisations",
	'4851' => "En compte",
	'4852' => "Effets à recevoir",
	'4857' => "Retenues de garantie",
	'4858' => "Factures à établir",
	'486' => "Créances sur cessions de titres de placement",
	'488' => "Autres créances hors activités ordinaires (h.a.o.)",
	'49' => "Dépréciations et risques provisionnés (Tiers)",
	'490' => "Dépréciations des comptes fournisseurs",
	'491' => "Dépréciations des comptes clients",
	'4911' => "Créances litigieuses",
	'4912' => "Créances douteuses",
	'492' => "Dépréciations des comptes personnel",
	'493' => "Dépréciations des comptes organismes sociaux",
	'494' => "Dépréciations des comptes état et collectivités publiques",
	'495' => "Dépréciations des comptes organismes internationaux",
	'496' => "Dépréciations des comptes associés et groupe",
	'4962' => "Associés, comptes courants",
	'4963' => "Associés, opérations faites en commun",
	'4966' => "Groupe, comptes courants",
	'497' => "Dépréciations des comptes débiteurs divers",
	'498' => "Dépréciations des comptes de créances h.a.o.",
	'4981' => "Créances sur cessions d'immobilisations",
	'4982' => "Créances sur cessions de titres de placement",
	'4983' => "Autres créances H.A.O.",
	'499' => "Risques provisionnés",
	'4991' => "Sur opérations d'exploitation",
	'4998' => "Sur opérations H.A.O.",
	'5' => "Comptes de trésorerie",
	'50' => "Titres de placement",
	'501' => "Titres du trésor et bons de caisse à court terme",
	'5011' => "Titres du Trésor à court terme",
	'5012' => "Titres d'organismes financiers",
	'5013' => "Bons de caisse à court terme",
	'502' => "Actions",
	'5021' => "Actions propres",
	'5022' => "Actions cotées",
	'5023' => "Actions non cotées",
	'5024' => "Actions démembrées (certificats d'investissement ; droits de vote)",
	'5025' => "Autres titres conférant un droit de propriété",
	'503' => "Obligations",
	'5031' => "Obligations émises par la société et rachetées par elle",
	'5032' => "Obligations cotées",
	'5033' => "Obligations non cotées",
	'5035' => "Autres titres conférant un droit de créance",
	'504' => "Bons de souscription",
	'5042' => "Bons de souscription d'actions",
	'5043' => "Bons de souscription d'obligations",
	'505' => "Titres négociables hors region",
	'506' => "Intérêts courus",
	'5061' => "Titres du Trésor et bons de caisse à court terme",
	'5062' => "Actions",
	'5063' => "Obligations",
	'508' => "Autres valeurs assimilées",
	'51' => "Valeurs à encaisser",
	'511' => "Effets à encaisser",
	'512' => "Effets à l'encaissement",
	'513' => "Chèques à encaisser",
	'514' => "Chèques à l'encaissement",
	'515' => "Cartes de crédit à encaisser",
	'518' => "Autres valeurs à l'encaissement",
	'5181' => "Warrants",
	'5182' => "Billets de fonds",
	'5185' => "Chèques de voyage",
	'5186' => "Coupons échus",
	'5187' => "Intérêts échus des obligations",
	'52' => "Banques",
	'521' => "Banques locales",
	'5211' => "Banques x",
	'5212' => "Banque y",
	'522' => "Banques autres états region",
	'523' => "Banques autres etats zone monetaire",
	'524' => "Banques hors zone monetaire",
	'526' => "Banques, interets courus",
	'53' => "Établissements financiers et assimilés",
	'531' => "Chèques postaux",
	'532' => "Trésor",
	'533' => "Sociétés de gestion et d'intermédiation (s.g.i.)",
	'536' => "Établissements financiers, intérêts courus",
	'538' => "Autres organismes financiers",
	'54' => "Instruments de trésorerie",
	'541' => "Options de taux d'intérêt",
	'542' => "Options de taux de change",
	'543' => "Options de taux boursiers",
	'544' => "Instruments de marchés à terme",
	'545' => "Avoirs d'or et autres métaux précieux", // Pièces, barres, louis d'or et autres métaux précieux (argent, diamant...) acquis en vue d'une cession à court terme. Ils jouent donc le rôle d'instruments de trésorerie
	'56' => "Banques, crédits de trésorerie et d'escompte",
	'561' => "Crédits de trésorerie",
	'564' => "Escompte de crédits de campagne",
	'565' => "Escompte de crédits ordinaires",
	'566' => "Banques, credits de tresorerie, interets courus",
	'57' => "Caisse",
	'571' => "Caisse siège social",
	'5711' => "en unités monétaires légales",
	'5712' => "en devises",
	'572' => "Caisse succursale A",
	'5721' => "en unités monétaires légales",
	'5722' => "en devises",
	'573' => "Caisse succursale B",
	'5731' => "En unités monétaires légales",
	'5732' => "En devises",
	'58' => "Régies d'avances, accréditifs et virements internes",
	'581' => "Régies d'avance",
	'582' => "Accréditifs",
	'585' => "Virements de fonds",
	'588' => "Autres virements internes",
	'59' => "Dépréciations et risques provisionnés (trésorerie)",
	'590' => "Dépréciations des titres de placement",
	'591' => "Dépréciations des titres et valeurs à encaisser",
	'592' => "Dépréciations des comptes banques",
	'593' => "Dépréciations des comptes établissements financiers et assimilés",
	'594' => "Dépréciations des comptes d’instruments de trésorerie",
	'599' => "Risques provisionnés à caractère financier",

	'6' =>"Comptes de charges des activités ordinaires",
	'60' => "Achats et variations de stocks",
	'601' => "Achats de marchandises",
	'6011' => "dans la Région", // À l' exception des achats effectués avec les entreprises du groupe
	'6012' => "hors Région", // À l' exception des achats effectués avec les entreprises du groupe
	'6013' => "aux entreprises du groupe dans la Région",
	'6014' => "aux entreprises du groupe hors Région",
	'6019' => "Rabais, Remises et Ristournes obtenus (non ventilés)",
	'602' => "Achats de matières premières et fournitures liées",
	'6021' => "dans la Région", // À l' exception des achats effectués avec les entreprises du groupe
	'6022' => "hors Région", // À l' exception des achats effectués avec les entreprises du groupe
	'6023' => "aux entreprises du groupe dans la Région",
	'6024' => "aux entreprises du groupe hors Région",
	'6029' => "Rabais, Remises et Ristournes obtenus (non ventilés)",
	'603' => "Variations des stocks de biens achetés",
	'6031' => "Variations des stocks de marchandises",
	'6032' => "Variations des stocks de matières premières et fournitures liées",
	'6033' => "Variations des stocks d'autres approvisionnements",
	'604' => "Achats stockés de matières et fournitures consommables",
	'6041' => "Matières consommables",
	'6042' => "Matières combustibles",
	'6043' => "Produits d'entretien",
	'6044' => "Fournitures d'atelier et d'usine",
	'6046' => "Fournitures de magasin",
	'6047' => "Fournitures de bureau",
	'6049' => "Rabais, Remises et Ristournes obtenus (non ventilés)",
	'605' => "Autres achats",
	'6051' => "Fournitures non stockables -Eau",
	'6052' => "Fournitures non stockables - Electricité",
	'6053' => "Fournitures non stockables – Autres énergies",
	'6054' => "Fournitures d'entretien non stockables",
	'6055' => "Fournitures de bureau non stockables",
	'6056' => "Achats de petit matériel et outillage",
	'6057' => "Achats d'études et prestations de services",
	'6058' => "Achats de travaux, matériels et équipements",
	'6059' => "Rabais, Remises et Ristournes obtenus (non ventilés)",
	'608' => "Achats d'emballages",
	'6081' => "Emballages perdus",
	'6082' => "Emballages récupérables non identifiables",
	'6083' => "Emballages à usage mixte",
	'6089' => "Rabais, Remises et Ristournes obtenus (non ventilés)",
	'61' => "Transports",
	'611 ' => "Transports sur achats(1)",
	'612 ' => "Transports sur ventes",
	'613 ' => "Transports pour le compte de tiers",
	'614 ' => "Transports du personnel",
	'616 ' => "Transports de plis",
	'618 ' => "Autres frais de transport",
	'6181 ' => "Voyages et déplacements",
	'6182 ' => "Transports entre établissements ou chantiers",
	'6183 ' => "Transports administratif",
	'62' => "Services extérieurs A",
	'621' => "Sous-traitance générale",
	'622' => "Locations et charges locatives",
	'6221' => "Locations de terrains",
	'6222' => "Locations de bâtiments",
	'6223' => "Locations de matériels et outillages",
	'6224' => "Malis sur emballages",
	'6225' => "Locations d'emballages",
	'6228' => "Locations et charges locatives diverses",
	'623' => "Redevances de crédit-bail et contrats assimilés",
	'6232' => "Crédit-bail immobilier",
	'6233' => "Crédit-bail mobilier",
	'6235' => "Contrats assimilés",
	'624' => "Entretien, réparations et maintenance",
	'6241' => "Entretien et réparations des biens immobiliers",
	'6242' => "Entretien et réparations des biens mobiliers",
	'6243' => "Maintenance",
	'6248' => "Autres entretiens et réparations",
	'625' => "Primes d'assurance",
	'6251' => "Assurances multirisques",
	'6252' => "Assurances matériel de transport",
	'6253' => "Assurances risques d'exploitation",
	'6254' => "Assurances responsabilité du producteur",
	'6255' => "Assurances insolvabilité clients",
	'6256' => "Assurances transport sur achats",
	'6257' => "Assurances transport sur ventes",
	'6258' => "Autres primes d'assurances",
	'626' => "Études, recherches et documentation",
	'6261' => "Études et recherches",
	'6265' => "Documentation générale",
	'6266' => "Documentation technique",
	'627' => "Publicité, publications, relations publiques",
	'6271' => "Annonces, insertions",
	'6272' => "Catalogues, imprimés publicitaires",
	'6273' => "Échantillons",
	'6274' => "Foires et expositions",
	'6275' => "Publications",
	'6276' => "Cadeaux à la clientèle",
	'6277' => "Frais de colloques, séminaires, conférences",
	'6278' => "Autres charges de publicité et relations publiques",
	'628' => "Frais de télécommunications",
	'6281' => "Frais de téléphone",
	'6282' => "Frais de télex",
	'6283' => "Frais de télécopie",
	'6288' => "Autres frais de télécommunications",
	'63' => "Services extérieurs B",
	'631' => "Frais bancaires",
	'6311' => "Frais sur titres (achat, vente, garde)",
	'6312' => "Frais sur effets",
	'6313' => "Location de coffres",
	'6315' => "Commissions sur cartes de crédit",
	'6316' => "Frais d'émission d'emprunts",
	'6318' => "Autres frais bancaires",
	'632' => "Rémunérations d'intermédiaires et de conseils",
	'6321' => "Commissions et courtages sur achats",
	'6322' => "Commissions et courtages sur ventes",
	'6323' => "Rémunérations des transitaires",
	'6324' => "Honoraires",
	'6325' => "Frais d'actes et de contentieux",
	'6328' => "Divers frais",
	'633' => "Frais de formation du personnel",
	'634' => "Redevances pour brevets, licences, logiciels et droits similaires",
	'6342' => "Redevances pour brevets, licences, concessions et droits similaires",
	'6343' => "Redevances pour logiciels",
	'6344' => "Redevances pour marques",
	'635' => "Cotisations",
	'6351' => "Cotisations",
	'6358' => "Concours divers",
	'637' => "Rémunérations de personnel extérieur à l'entreprise",
	'6371' => "Personnel intérimaire",
	'6372' => "Personnel détaché ou prêté à l'entreprise",
	'638' => "Autres charges externes",
	'6381' => "Frais de recrutement du personnel",
	'6382' => "Frais de déménagement",
	'6383' => "Réceptions",
	'6384' => "Missions",
	'64' => "Impôts et taxes",
	'641' => "Impôts et taxes directs",
	'6411' => "Impôts fonciers et taxes annexes",
	'6412' => "Patentes, licences et taxes annexes",
	'6413' => "Taxes sur appointements et salaires",
	'6414' => "Taxes d'apprentissage",
	'6415' => "Formation professionnelle continue",
	'6418' => "Autres impôts et taxes directs",
	'645' => "Impôts et taxes indirects",
	'646' => "Droits d'enregistrement",
	'6461' => "Droits de mutation",
	'6462' => "Droits de timbre",
	'6463' => "Taxes sur les véhicules de société",
	'6464' => "Vignettes",
	'6468' => "Autres droits",
	'647' => "Pénalités et amendes fiscales",
	'6471' => "Pénalités d'assiette, impôts directs",
	'6472' => "Pénalités d'assiette, impôts indirects",
	'6473' => "Pénalités de recouvrement, impôts directs",
	'6474' => "Pénalités de recouvrement, impôts indirects",
	'6478' => "Autres amendes pénales et fiscales",
	'648' => "Autres impôts et taxes",
	'65' => "Autres charges de gestion courante",
	'651' => "Pertes sur créances clients et autres débiteurs",
	'6511' => "Clients",
	'6515' => "Autres débiteurs",
	'652' => "Quote-part de résultat sur opérations faites en commun",
	'6521' => "Quote-part transférée de bénéfices (comptabilité du gérant)",
	'6525' => "Pertes imputées par transfert (comptabilité des associés non gérants)",
	'653' => "Quote-part de résultat annulée sur exécution partielle de contrats pluri-exercices",
	'654' => "Valeur comptable des cessions courantes d'immobilisations",
	'658' => "Charges diverses",
	'6581' => "Jetons de présence et autres rémunérations d'administrateurs",
	'6582' => "Dons",
	'6583' => "Mécénat",
	'659' => "Charges provisionnées d'exploitation",
	'6591' => "sur risques à court terme",
	'6593' => "sur stocks",
	'6594' => "sur créances",
	'6598' => "Autres charges provisionnées",
	'66' => "Charges de personnel",
	'661' => "Rémunérations directes versées au personnel national",
	'6611' => "Appointements salaires et commissions",
	'6612' => "Primes et gratifications",
	'6613' => "Congés payés",
	'6614' => "Indemnités de préavis, de licenciement et de recherche d'embauche",
	'6615' => "Indemnités de maladie versées aux travailleurs",
	'6616' => "Supplément familial",
	'6617' => "Avantages en nature",
	'6618' => "Autres rémunérations directes",
	'662' => "Rémunérations directes versées au personnel non national",
	'6621' => "Appointements salaires et commissions",
	'6622' => "Primes et gratifications",
	'6623' => "Congés payés",
	'6624' => "Indemnités de préavis, de licenciement et de recherche d'embauche",
	'6625' => "Indemnités de maladie versées aux travailleurs",
	'6626' => "Supplément familial",
	'6627' => "Avantages en nature",
	'6628' => "Autres rémunérations directes",
	'663' => "Indemnités forfaitaires versées au personnel",
	'6631' => "Indemnités de logement",
	'6632' => "Indemnités de représentation",
	'6633' => "Indemnités d'expatriation",
	'6638' => "Autres indemnités et avantages divers",
	'664' => "Charges sociales",
	'6641' => "Charges sociales sur rémunération du personnel national",
	'6642' => "Charges sociales sur rémunération du personnel non national",
	'666' => "Rémunérations et charges sociales de l'exploitant individuel",
	'6661' => "Rémunération du travail de l'exploitant",
	'6662' => "Charges sociales",
	'667' => "Rémunération transférée de personnel extérieur",
	'6671' => "Personnel intérimaire",
	'6672' => "Personnel détaché ou prêté à l’entreprise",
	'668' => "Autres charges sociales",
	'6681' => "Versements aux Syndicats et Comités d'entreprise, d'établissement",
	'6682' => "Versements aux Comités d'hygiène et de sécurité",
	'6683' => "Versements aux autres oeuvres sociales",
	'6684' => "Médecine du travail et pharmacie",
	'67' => "Frais financiers et charges assimilées",
	'671' => "Intérêts des emprunts",
	'6711' => "Emprunts obligataires",
	'6712' => "Emprunts auprès des établissements de crédit",
	'6713' => "Dettes liées à des participations",
	'672' => "Intérêts dans loyers de crédit-bail et contrats assimilés",
	'6721' => "Intérêts dans loyers de crédit-bail immobilier",
	'6722' => "Intérêts dans loyers de crédit-bail mobilier",
	'6723' => "Intérêts dans loyers des autres contrats",
	'673' => "Escomptes accordés",
	'674' => "Autres intérêts",
	'6741' => "Avances reçues et dépôts créditeurs",
	'6742' => "Comptes courants bloqués",
	'6743' => "Intérêts sur obligations cautionnées",
	'6744' => "Intérêts sur dettes commerciales",
	'6745' => "Intérêts bancaires et sur opérations de trésorerie et d’escompte",
	'6748' => "Intérêts sur dettes diverses",
	'675' => "Escomptes des effets de commerce",
	'676' => "Pertes de change",
	'677' => "Pertes sur cessions de titres de placement",
	'678' => "Pertes sur risques financiers",
	'6781' => "sur rentes viagères",
	'6782' => "sur opérations financières",
	'6784' => "sur instruments de trésorerie",
	'679' => "Charges provisionnées financières",
	'6791' => "sur risques financiers",
	'6795' => "sur titres de placement",
	'6798' => "Autres charges provisionnées financières",
	'68' => "Dotations aux amortissements",
	'681' => "Dotations aux amortissements d'exploitation",
	'6811' => "Dotations aux amortissements des charges immobilisées",
	'6812' => "Dotations aux amortissements des immobilisations incorporelles",
	'6813' => "Dotations aux amortissements des immobilisations corporelles",
	'687' => "Dotations aux amortissements à caractère financier",
	'6872' => "Dotations aux amortissements des primes de remboursement des obligations",
	'6878' => "Autres dotations aux amortissements à caractère financier",
	'69' => "Dotations aux provisions",
	'691' => "Dotations aux provisions d'exploitation",
	'6911' => "pour risques et charges",
	'6912' => "pour grosses réparations",
	'6913' => "pour dépréciation des immobilisations incorporelles",
	'6914' => "pour dépréciation des immobilisations corporelles",
	'695' => "Dotations aux usines",
	'697' => "Dotations aux provisions financières",
	'697' => "Dotations aux provisions financières",
	'6971' => "pour risques et charges",
	'6972' => "pour dépréciation des immobilisations financières",
	'7' => "Comptes de produits des activités ordinaires",
	'70' => "Ventes",
	'701' => "Ventes de marchandises",
	'7011' => "dans la Région", // À l'exclusion des ventes faites à des entreprises du groupe
	'7012' => "hors Région", // À l'exclusion des ventes faites à des entreprises du groupe
	'7013' => "aux entreprises du groupe dans la Région",
	'7014' => "aux entreprises du groupe hors Région",
	'702' => "Ventes de produits finis",
	'7021' => "dans la Région", // À l'exclusion des ventes faites à des entreprises du groupe
	'7022' => "hors Région", // À l'exclusion des ventes faites à des entreprises du groupe
	'7023' => "aux entreprises du groupe dans la Région",
	'7024' => "aux entreprises du groupe hors Région",
	'703' => "Ventes de produits intermédiaires",
	'7031' => "dans la Région", // À l'exclusion des ventes faites à des entreprises du groupe
	'7032' => "hors Région", // À l'exclusion des ventes faites à des entreprises du groupe
	'7033' => "aux entreprises du groupe dans la Région",
	'7034' => "aux entreprises du groupe hors Région",
	'704' => "Ventes de produits résiduels",
	'7041' => "dans la Région", // À l'exclusion des ventes faites à des entreprises du groupe
	'7042' => "hors Région", // À l'exclusion des ventes faites à des entreprises du groupe
	'7043' => "aux entreprises du groupe dans la Région",
	'7044' => "aux entreprises du groupe hors Région",
	'705' => "Travaux facturés",
	'7051' => "dans la Région", // À l'exclusion des ventes faites à des entreprises du groupe
	'7052' => "hors Région", // À l'exclusion des ventes faites à des entreprises du groupe
	'7053' => "aux entreprises du groupe dans la Région",
	'7054' => "aux entreprises du groupe hors Région",
	'706' => "Services vendus",
	'7061' => "dans la Région", // À l'exclusion des ventes faites à des entreprises du groupe
	'7062' => "hors Région", // À l'exclusion des ventes faites à des entreprises du groupe
	'7063' => "aux entreprises du groupe dans la Région",
	'7064' => "aux entreprises du groupe hors Région",
	'707' => "Produits accessoires",
	'7071' => "Ports, emballages perdus et autres frais facturés",
	'7072' => "Commissions et courtages", // À inscrire au compte 706 si ces produits correspondent à une activité principale de l’entreprise
	'7073' => "Locations", // À inscrire au compte 706 si ces produits correspondent à une activité principale de l’entreprise
	'7074' => "Bonis sur reprises et cessions d'emballages",
	'7075' => "Mise à disposition de personnel", // À inscrire au compte 706 si ces produits correspondent à une activité principale de l’entreprise
	'7076' => "Redevances pour brevets, logiciels, marques et droits similaires", // À inscrire au compte 706 si ces produits correspondent à une activité principale de l’entreprise
	'7077' => "Services exploités dans l'intérêt du personnel",
	'7079' => "Autres produits accessoires",
	'71' => "Subventions d'exploitation",
	'711' => "Sur produits à l'exportation",
	'712' => "Sur produits à l'importation",
	'713' => "Sur produits de péréquation",
	'718' => "Autres subventions d'exploitation",
	'7181' => "Versées par l'État et les collectivités publiques",
	'7182' => "Versées par les organismes internationaux",
	'7183' => "Versées par des tiers",
	'72' => "Production immobilisée",
	'721' => "Immobilisations incorporelles",
	'722' => "Immobilisations corporelles",
	'726' => "Immobilisations financières", // En cas d’offre publique d’échange (O.P.E.) ou d’achat (O.P.A.) notamment.
	'73' => "Variations de stocks de biens et de services produits",
	'734' => "Variations des stocks de produits en cours",
	'7341' => "Produits en cours",
	'7342' => "Travaux en cours",
	'735' => "Variations des en-cours de services",
	'7351' => "Études en cours",
	'7352' => "Prestations de services en cours",
	'736' => "Variations des stocks de produits finis",
	'737' => "Variations des stocks de produits intermédiaires et résiduels",
	'7371' => "Produits intermédiaires",
	'7372' => "Produits résiduels",
	'75' => "Autres produits de gestion courante",
	'752' => "Quote-part de résultat sur opérations faites en commun",
	'7521' => "Quote-part transférée de pertes (comptabilité du gérant)",
	'7525' => "Bénéfices attribués par transfert (comptabilité des associés non gérants)",
	'753' => "Quote-part de résultat sur exécution partielle de contrats pluri-exercices",
	'754' => "Produits des cessions courantes d'immobilisations",
	'758' => "Produits divers",
	'7581' => "Jetons de présence et autres rémunérations d'administrateurs",
	'7582' => "Indemnités d’assurances reçues",
	'759' => "Reprises de charges provisionnées d'exploitation",
	'7591' => "sur risques à court terme",
	'7593' => "sur stocks",
	'7594' => "sur créances",
	'7598' => "sur autres charges provisionnées",
	'77' => "Revenus financiers et produits assimilés",
	'771' => "Intérêts de prêts",
	'772' => "Revenus de participations",
	'773' => "Escomptes obtenus",
	'774' => "Revenus de titres de placement",
	'776' => "Gains de change",
	'777' => "Gains sur cessions de titres de placement",
	'778' => "Gains sur risques financiers",
	'7781' => "sur rentes viagères",
	'7782' => "sur opérations financières",
	'7784' => "sur instruments de trésorerie",
	'779' => "Reprises de charges provisionnées financières",
	'7791' => "sur risques financiers",
	'7795' => "sur titres de placement",
	'7798' => "autres charges provisionnées financière",
	'78' => "Transferts de charges",
	'781' => "Transferts de charges d'exploitation",
	'787' => "Transferts de charges financieres",
	'79' => "Reprises de provisions",
	'791' => "Reprises de provisions d'exploitation",
	'7911' => "pour risques et charges",
	'7912' => "pour grosses réparations",
	'7913' => "pour dépréciation des immobilisations incorporelles",
	'7914' => "pour dépréciation des immobilisations corporelles",
	'797' => "Reprises de provisions financières",
	'7971' => "pour risques et charges",
	'7972' => "pour dépréciation des immobilisations financières",
	'798' => "Reprises d'amortissements", // Cas de révision de plan d’amortissement

	'8' => "Comptes des autres charges et des autres produits", // Les comptes de la classe 8 impaire sont des charges et les comptes de la classe 8 paire sont des produits
	'81' => "Valeurs comptables des cessions d'immobilisations",
	'811' => "Immobilisations incorporelles",
	'812' => "Immobilisations corporelles",
	'816' => "Immobilisations financières",
	'82' => "Produits des cessions d'immobilisations",
	'821' => "Immobilisations incorporelles",
	'822' => "Immobilisations corporelles",
	'826' => "Immobilisations financières",
	'83' => "Charges hors activités ordinaires (H.A.O)",
	'831' => "Charges h.a.o. constatées",
	'834' => "Pertes sur créances h.a.o.",
	'835' => "Dons et libéralités accordés",
	'836' => "Abandons de créances consentis",
	'839' => "Charges provisionnées h.a.o.",
	'84' => "Produits \hors activités ordinaires (H.A.O)",
	'841' => "Produits h.a.o constatés",
	'845' => "Dons et libéralités obtenus",
	'846' => "Abandons de créances obtenus",
	'848' => "Transferts de charges H.A.O",
	'849' => "Reprises des charges provisionnées H.A.O.",
	'85' => "Dotations hors activités ordinaires (H.A.O)",
	'851' => "Dotations aux provisions réglementées",
	'852' => "Dotations aux amortissements h.a.o.",
	'853' => "Dotations aux provisions pour dépréciation H.A.O.",
	'854' => "Dotations aux provisions pour risques et charges H.A.O.",
	'858' => "Autres dotations H.A.O.",
	'86' => "Reprises hors activités ordinaires (H.A.O)",
	'861' => "Reprises de provisions réglementées",
	'862' => "Reprises d’amortissements",
	'863' => "Reprises de provisions pour dépréciation H.A.O.",
	'864' => "Reprises de provisions pour risques et charges H.A.O.",
	'865' => "Reprises de subventions d’investissement",
	'868' => "Autres reprises h.a.o.",
	'87' => "Participation des travailleurs",
	'871' => "Participation légale aux bénéfices",
	'874' => "Participation contractuelle aux bénéfices",
	'878' => "Autres participations",
	'88' => "Subventions d'équilibre",
	'881' => "État",
	'884' => "Collectivités publiques",
	'886' => "Groupe",
	'888' => "Autres",
	'89' => "Impôts sur le résultat",
	'891' => "Impôts sur les bénéfices de l'exercice",
	'8911' => "Activités exercées dans l'État",
	'8912' => "Activités exercées dans les autres États de la Région",
	'8913' => "Activités exercées hors Région",
	'892' => "Rappel d'impôts sur résultats antérieurs",
	'895' => "Impôt minimum forfaitaire (I.M.F.)",
	'899' => "Dégrèvements et annulations d’impôts sur résultats antérieurs",
	'8991' => "Dégrèvements",
	'8994' => "Annulations pour pertes rétroactives",

	'9' => "Comptabilité des engagements & Comptabilité analytique de gestion",
	'90' => "Engagements obtenus et engagements accordés",
	'901' => "Engagements de financement obtenus",
	'9011' => "Crédits confirmés obtenus",
	'9012' => "Emprunts restant à encaisser",
	'9013' => "Facilités de financement renouvelables",
	'9014' => "Facilités d'émission",
	'9018' => "Autres engagements de financement obtenus",
	'902' => "Engagements de garantie obtenus",
	'9021' => "Avals obtenus",
	'9022' => "Cautions, garanties obtenues",
	'9023' => "Hypothèques obtenues",
	'9024' => "Effets endossés par des tiers",
	'9028' => "Autres garanties obtenues",
	'903' => "Engagements réciproques",
	'9031' => "Achats de marchandises à terme",
	'9032' => "Achats à terme de devises",
	'9033' => "Commandes fermes des clients et compte",
	'9038' => "Autres engagements réciproques",
	'904' => "Autres engagements obtenus",
	'9041' => "Abandons de créances conditionnels",
	'9043' => "Ventes avec clause de réserve de propriété et compte",
	'9048' => "Divers engagements obtenus",
	'905' => "Engagements de financement accordés",
	'9051' => "Crédits accordés non décaissés et compte",
	'9058' => "Autres engagements de financement accordés",
	'906' => "Engagements de garantie accordés",
	'9061' => "Avals accordés",
	'9062' => "Cautions, garanties accordées",
	'9063' => "Hypothèques accordées",
	'9064' => "Effets endossés par l'entreprise",
	'9068' => "Autres garanties accordées",
	'907' => "Engagements réciproques",
	'9071' => "Ventes de marchandises à terme",
	'9072' => "Ventes à terme de devises",
	'9073' => "Commandes fermes aux fournisseurs",
	'9078' => "Autres engagements réciproques",
	'908' => "Autres engagements accordés",
	'9081' => "Annulations conditionnelles de dettes",
	'9082' => "Engagements de retraite",
	'9083' => "Achats avec clause de réserve de propriété",
	'9088' => "Divers engagements accordés",
	'91' => "Contreparties des engagements",
	'92' => "Comptes de section", // ex: Comptes réfléchis
	'93' => "Comptes de coût et prix de revient", // ex:  Comptes de reclassement
	'94' => "Compte des magasins", // ex: Compte des coûts
	'95' => "Comptes de cession de commande", // stocks
	'96' => "Comptes des écarts sur coût préétablis",
	'97' => "Comptes de différence d'incorporation",
	'98' => "Comptes de résultats",
	'99' => "Comptes de liaison inter unités",

);

?>
